@ECHO off
REM
REM    Licensed Materials - Property of IBM
REM
REM    "Restricted Materials of IBM"
REM
REM    5724-U38, 5724-U39, 5724-U48
REM
REM     Copyright IBM Corp. 2016 All Rights Reserved
REM
REM     Copyright 2016 UNICOM Systems, Inc. - All Rights Reserved
REM
REM    US Government Users Restricted Rights - Use, duplication or
REM    disclosure restricted by GSA ADP Schedule Contract with
REM    IBM Corp.
REM


:: This batch file runs the ODPPJavaSample program in the ODPP\Samples directory.
:: It is assummed that the batch file is being run from the ODPP\Samples\JavaAPI directory in a ModAPP installation.

SET CURRDIR=%~dp0
SET MODDIR=%CURRDIR%..\..\..


:: Set ODPP environment variables:
::    ODPPLIBL - The directory containing ODPP binaries 
::    ODPPLL   - The directory containing the ODPP license file
::    ODPPTRCL - The directory to which ODPP diagnostic traces will be written
SET ODPPLIBL=%MODDIR%\ODPP\Images64\win\bin\
SET ODPPLL=%MODDIR%\ODPP\Images64\win\bin\
SET ODPPTRCL=%MODDIR%\ODPP\Images64\win\trace\
if NOT EXIST %ODPPLIBL% (
 SET ODPPLIBL=%MODDIR%\ODPP\Images32\win\bin\
 SET ODPPLL=%MODDIR%\ODPP\Images32\win\bin\
 SET ODPPTRCL=%MODDIR%\ODPP\Images32\win\trace\
)

:: If a java is not in the system PATH, then set the ODPPJAVAPATH variable in the line below.
:: For example:  ODPPJAVAPATH=C:\Program Files (x86)\AdoptOpenJDK\jre-8.0.265.01-hotspot\bin
set ODPPJAVAPATH=

if ["%ODPPJAVAPATH%"]==[""] (
   :: ODPPJAVAPATH was not specified, so make sure java is in path
   java 2> NUL
   if ERRORLEVEL 9009 ( 
      echo Error - Java is not in PATH. Please edit this script and set ODPPJAVAPATH
      echo         to Java's bin directory -- e.g. "ODPPJAVAPATH=C:\Program Files (x86)\AdoptOpenJDK\jre-8.0.265.01-hotspot\bin"  	  
	  goto ERROR
   )
   set JAVACMD=java
) else (
   if exist "%ODPPJAVAPATH%\java.exe" (
     set JAVACMD="%ODPPJAVAPATH%\java"
     ) else (
	    echo Error - The setting of  ODPPJAVAPATH in this script is incorrect.
        echo         "%ODPPJAVAPATH%\java.exe" does not exist
	    goto ERROR
     )
   )
)

:: Add ODPP bin directory to path.
:: If this is not being run from within a ModAPP installation, then please modify the
:: statements below to reflect the location of ODPP.
ECHO ;%PATH%; | find /C /I ";%ODPPLIBL%;" >NUL
IF "%ERRORLEVEL%" == "0" GOTO END
SET ERRORLEVEL=0
SET PATH=%PATH%;%ODPPLIBL%
:END

:: Execute the program 
%JAVACMD% -classpath "%CURRDIR%\ODPPJavaSample.jar;%ODPPLIBL%\odppjava.jar" com.ibm.odppjavasample.ODPPJavaSample
:ERROR
pause
