/* -cr_beg-
* ********************************************************************
* IBM Confidential
* OCO Source Materials
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
* (C) Copyright IBM Corp. 2013
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
* ********************************************************************
* -cr_end-
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "odpp_exit.h"

// Declare the hash exit functions. Since the exit is always dynamically loaded, 
// pointers to the functions will be obtained at run-time by name - so the names 
// are important and are case sensitive.
exit_init init;
exit_get_key get_key;
exit_term term;

// NOTE:
// The memory in which the key is provided by the exit must be explicitly allocated 
// by the exit and will be overwritten by the hashing library to maintain security. 
// This memory must be explicitly freed by the exit in the term function.

// Declare the key buffer pointer
unsigned char *gpKey = NULL;
// hash seed 
unsigned char Seed[] = "key";

int init(void)
{
    return EXIT_RC_OK;
}

int get_key(unsigned char **key, unsigned int *key_length, unsigned int *obfuscator)
{
    int rc = EXIT_RC_OK;
    size_t KeyLenBytes = sizeof(Seed) - 1;
    // allocate memory for the secret key (hash seed)
    gpKey = (unsigned char *)malloc(KeyLenBytes);
    if (NULL != gpKey) 
    {
       // copy the key (hash seed) to the allocated key buffer 
       memcpy(gpKey, &Seed[0], KeyLenBytes);
       // set the key 
       *key = gpKey;
       // set the length of the key buffer in bytes
       *key_length = (unsigned int)KeyLenBytes;
       // set the obfuscator
       *obfuscator = 54321;
    } 
    else 
    {
       // return an error if memory allocation failed 
       rc = EXIT_RC_INTERNAL_ERROR;
    }    
    return rc;
}

void term(void)
{
   // Free the memory for the key
   if(NULL != gpKey)
   {
      free(gpKey);
      gpKey = NULL;
   }
}
