/* 
* -cr_beg-
* ********************************************************************
* IBM Confidential
* OCO Source Materials
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
* (C) Copyright IBM Corp. 2012
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
* ********************************************************************
* -cr_end-
*/ 

/*----------------------------------------------------------------------------
 *	File Name:  source.h
 *
 *	Purpose:    Provides the declares required for my masking library
 *
 *---------------------------------------------------------------------------*/


#ifndef __MYSRC__
#define __MYSRC__

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <wchar.h>

#include "ODPPCmnApiX.h"
#include "ODPPDataTypesH.h"
#include "errcodes.h"
#include "params.h"

#ifdef _WIN32  
   #include <windows.h>
#else
   #include <strings.h>
   #include <sys/types.h>
   #include <sys/errno.h>
   #include <math.h>
   #include <unistd.h>
   #ifdef _SUSE
      #include <ctype.h>
      #include <wctype.h>
   #endif
#endif

#ifndef TRUE
   #define TRUE   	   			1
#endif

#ifndef FALSE
   #define FALSE	   		   	0
#endif

#ifdef _WIN32
   #define WCSNCMP   wcsncmp
   #define WCSNICMP _wcsnicmp
   #define STRICMP   _stricmp
   #define STRNICMP  _strnicmp
   #define WCSICMP   _wcsicmp
   #define WCSUPPER  _wcsupr
   #define WCSLEN    wcslen
#else
   #define WCSNCMP   wcsncmp
   #define WCSNICMP  wsncasecmp   
   #define STRICMP   strcasecmp
   #define STRNICMP  strncasecmp
   #define WCSICMP   wcscasecmp
   #define WCSLEN    wcslen
#endif


#define CHECK_SRC_COL   	   1
#define CHECK_DST_COL	      2
//#define CHECK_SRC_DEST_COL  3

#define DEST_COL_TYPE_INDEX   1
#define DEST_COL_TYPE_NAME    2


#define MY_PROVIDER_NAME    L"My Service Provider"
#define MY_PROVIDER_DESC    L"My service provider for addition of two columns"



#define MOVENEXT(ptr)                     \
         if(NULL != ptr){                 \
         if(NULL == ptr->pNext) ptr++;    \
         else ptr = ptr->pNext;}


/*This structure is used to hold the my Provider specific control information. 
  Data member of this structure will be allocated and store in the CtrlBlk->pExt */
typedef struct s_DpMyCtrlBlk_def
{
	short	            sSrc1ColIndex;  /* Source col 1 index */
	short	            sSrc2ColIndex;  /* Source col 2 index */
	short	            sDestColIndex;  /* Destination col index */
	int               iOperator;  /* Method of operations */
	DP_FIELD_DEF_X   *pDstCol;       /* Destination column */
}DP_MYCTRL_DEF;

/* MACRO TO CONVERT the passed in value to a wide string */
#if defined(__ZOSC__) || defined(__ZOSCPP__)
   #define ODPPCNVTOWSTR1(CAT_TOWIDE) u##CAT_TOWIDE
#else
   #define ODPPCNVTOWSTR1(CAT_TOWIDE) L##CAT_TOWIDE
#endif

///* Provider's Init to initialize the provider  */
//RETVAL Init(DP_BLK_DEF *pCtrlBlk,
//            DP_SVC_DEF *pSvcDef);
//
///* Provider's Service to perform the requested service */
//RETVAL Service(short sMethod,             
//               DP_BLK_DEF *pCtrlBlk,      
//               DP_ROWSET_DEF *pRowSet);
//
///* Provider's Terminate to deinitialize the Provider */
//RETVAL Terminate(DP_BLK_DEF *pCtrlBlk);
//
///* Provider GetDetails provides the provider information*/
//RETVAL GetDetails(DP_PRV_DEF *pProviderDetails);
//
///* Provider GetErrorMsg Returns the error message for the supplied Error Code and 
//   language supplied */
//RETVAL GetErrorMsg(RETVAL ErrorCode,      
//                   int iLanguage,         
//                   ODPP_WCHAR *pErrMsg); 
//
///* Returns the information requested by the caller */
// RETVAL GetInfo(DP_BLK_DEF *pCtrlBlk,
//                short sRequest,
//                void *ptr,
//                int *pBufLen); 

#endif
