/*
    IBM Confidential

    OCO Source Materials

    5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37

     Copyright IBM Corp. 2016

    The source code for this program is not published or otherwise
    divested of its trade secrets, irrespective of what has been
    deposited with the U.S. Copyright Office.


     Copyright 2016 UNICOM Systems, Inc. - All Rights Reserved

    Highly Confidential Material - All Rights Reserved

    THE INFORMATION CONTAINED HEREIN CONSTITUTES AN UNPUBLISHED
    WORK OF UNICOM SYSTEMS, INC. ALL RIGHTS RESERVED.
    NO MATERIAL FROM THIS WORK MAY BE REPRINTED,
    COPIED, OR EXTRACTED WITHOUT WRITTEN PERMISSION OF
    UNICOM SYSTEMS, INC.  818-838-0606

*/

/*----------------------------------------------------------------------------
File Name:  ODPPCmnErrCodes.h

Purpose:    Provides the Error Codes retunrned by the API to the external
            calling application
            The error codes will be 4 byte values declared as hex values
            and will be printed into log files as hex values only.

Author:
   Ritesh Tandon     IBM ISL 29/Dec/2009

 * RTC/JAZZ change log
 *
 *  1 Aug 2010 EdL 1.0 WI 8969
 * Added additionl error codes -
 * TRIM functionality
 *
 * 23 Mar 2010 EdL 1.0 WI 7949
 * Added additional error codes -
 * Source consisting of spaces does not return error and
 * iDstBufLen is not set to size of output
 *
 * 22 Mar 2010 EdL 1.0 WI 7951
 * Added additional error codes -
 * ODPP_OPR_COL_LENGTH specified with UNIQUE does not fail the process
 *
 * 23 Apr 2021 PWS 1.0 WI 77660
 * Added additional Loopup error codes -
 *
----------------------------------------------------------------------------*/
#ifndef __ODPPCMNERRCODES__
#define __ODPPCMNERRCODES__

#include "odpp_hash_err_codes.h"

#define ODPPSUCCESS                       0
#define ODPPFAILURE                       -1
#define ODPPSUCCESS_WITH_INFO             -2

/*Upper boundary of error range for each module to use in GetErrorMsg*/
#define PRVAPIMAX                   (PRVAPIBASE + 72)
#define OSLIBMAX                    (OSLIBBASE + MUTEX_BASE + 13)
#define LISTMAX                     (LISTBASE + 8)
#define THBLKMAX                    (THBLKBASE + 2)
#define CCNMAX                      (CCNBASE + 51)
#define NIDMAX                      (NIDBASE + 227)
#define EMLMAX                      (EMLBASE + 50)
#define COLMAX                      (COLBASE + 39)
#define LKPMAX                      (LKPBASE + 61)
#define LDSMAX                      (LDSDB2BASE + 32)
#define HASHMAX                     (HASHBASE + 49)
#define AGEMAX                      (AGEBASE + 24)

#define JNIERRBASE                   0x10000000
#define JNIERRMAX                   (JNIERRBASE + 96)

/*=======================================================
   Common Framework error codes
=======================================================*/
/* Range 0x00000001 (1) to 0x00000FFF (4095)  -> i.e. 4095 error codes */

/*=======================================================
   Provide API related error codes
=======================================================*/
/* Range 0x00000001 to 0x000004E2 i.e. total of 1250 error codes*/
#define PRVAPIBASE                                 0x00000001

#define ODPP_FRMW_ERR_CTRLBLK_MALLOC_FAILED        PRVAPIBASE + 0
#define ODPP_FRMW_INFO_USERLIB_FOUND               PRVAPIBASE + 1
#define ODPP_FRMW_INFO_ODPPLIB_FOUND               PRVAPIBASE + 2
#define ODPP_FRMW_INFO_INVALID_OPERAND             PRVAPIBASE + 3
#define ODPP_FRMW_ERR_NO_OPERANDS                  PRVAPIBASE + 4
#define ODPP_FRMW_ERR_NO_FIELD_DEFS                PRVAPIBASE + 5
#define ODPP_FRMW_ERR_NO_SWITCH_SPECIFIED          PRVAPIBASE + 6
#define ODPP_FRMW_ERR_NO_SOURCECOL_SPECIFIED       PRVAPIBASE + 7
#define ODPP_FRMW_ERR_INVALID_SOURCE               PRVAPIBASE + 8
#define ODPP_FRMW_ERR_METHOD_RANDOM_WITH_SRCFLAGS  PRVAPIBASE + 9
#define ODPP_FRMW_ERR_INVALID_METHOD               PRVAPIBASE + 10
#define ODPP_FRMW_ERR_SRCCOL_NOTFOUND              PRVAPIBASE + 11
#define ODPP_FRMW_ERR_NULL_SVCTOKEN                PRVAPIBASE + 12
#define ODPP_FRMW_ERR_NULL_SVCID                   PRVAPIBASE + 13
#define ODPP_FRMW_ERR_NULL_SVCDEF                  PRVAPIBASE + 14
#define ODPP_FRMW_ERR_INVALID_SVCTOKEN             PRVAPIBASE + 15
#define ODPP_FRMW_ERR_NULL_ROWSET                  PRVAPIBASE + 16
#define ODPP_FRMW_ERR_SVCTOKEN_NOPROVIDER          PRVAPIBASE + 17
#define ODPP_FRMW_ERR_LIST_REMOVENODE_FAILED       PRVAPIBASE + 19
#define ODPP_FRMW_ERR_SWITCH_VAL_MALLOC_FAILED     PRVAPIBASE + 22
#define ODPP_FRMW_ERR_FLDDEF_COPY_MALLOC_FAILED    PRVAPIBASE + 23
#define ODPP_FRMW_ERR_FLD_CNV_BLK_MALLOC_FAILED    PRVAPIBASE + 24
#define ODPP_FRMW_ERR_NULL_CNV_BLK                 PRVAPIBASE + 25
#define ODPP_FRMW_ERR_INT_VALUE_EXCEEDED           PRVAPIBASE + 26
#define ODPP_FRMW_ERR_ZERO_LENGTH                  PRVAPIBASE + 29
#define ODPP_FRWM_ERR_NULL_ENUM_COUNT              PRVAPIBASE + 30
#define ODPP_FRWM_ERR_INVALID_ENUM_COUNT           PRVAPIBASE + 45
#define ODPP_FRMW_ERR_SRCCOL_MALLOC_FAILED         PRVAPIBASE + 46
#define ODPP_FRMW_ERR_NULL_COL                     PRVAPIBASE + 47
#define ODPP_FRMW_ERR_DATATYPE_NOT_SUPPORTED       PRVAPIBASE + 48
#define ODPP_FRMW_INFO_DATATYPE_LEN_NA             PRVAPIBASE + 49
#define ODPP_FRWM_ERR_ERRFILEPATH_MALLOC_FAILED    PRVAPIBASE + 50
#define ODPP_FRWM_ERR_PRV_ALREADY_INITIALIZED      PRVAPIBASE + 52
#define ODPP_FRWM_ERR_INVALID_YEAR                 PRVAPIBASE + 53
#define ODPP_FRWM_ERR_INVALID_DATE                 PRVAPIBASE + 54
#define ODPP_FRWM_ERR_INVALID_MONTH                PRVAPIBASE + 55
#define ODPP_FRWM_ERR_INVALID_HOUR                 PRVAPIBASE + 56
#define ODPP_FRWM_ERR_INVALID_MINUTE               PRVAPIBASE + 57
#define ODPP_FRWM_ERR_INVALID_SECOND               PRVAPIBASE + 58
#define ODPP_FRWM_ERR_PARSING_SRC_COLS             PRVAPIBASE + 60
#define ODPP_FRWM_INFO_GETINFO_NOT_DEFINED         PRVAPIBASE + 61
#define ODPP_FRMW_INFO_REQUEST_NOT_SUPPORTED       PRVAPIBASE + 62
#define ODPP_FRMW_ERR_GETINFO_BUFFER_SHORT         PRVAPIBASE + 63
#define ODPP_FRMW_INFO_DATATYPE_LEN_EXTRA_NEEDED   PRVAPIBASE + 64
#define ODPP_FRMW_ERR_INVALID_FORMAT_CODE          PRVAPIBASE + 66
#define ODPP_FRMW_ERR_EAB_MALLOC_FAILED            PRVAPIBASE + 67
#define ODPP_FRMW_ERR_ERROR_BLOCK_FETCH_FAILED     PRVAPIBASE + 71
#define ODPP_FRMW_ERR_SRCOLIDX_EXCEEDS_FIELD_COUNT PRVAPIBASE + 72
#define ODPP_FRMW_INFO_SOURCE_ZEROLENGTH           PRVAPIBASE + 73
#define ODPP_FRMW_INFO_SOURCE_ZERO                 PRVAPIBASE + 74
#define ODPP_FRMW_ERR_LIC_PATH_CONV_FAILED         PRVAPIBASE + 75
#define ODPP_FRMW_ERR_INIT_OP_DEF_MALLOC_FAILED    PRVAPIBASE + 76
#define ODPP_FRMW_ERR_PARAM_W_VAL_MALLOC_FAILED    PRVAPIBASE + 77
#define ODPP_FRMW_ERR_FIELD_DEF_MALLOC_FAILED      PRVAPIBASE + 78
#define ODPP_FRMW_ERR_PRV_DEF_MALLOC_FAILED        PRVAPIBASE + 79
#define ODPP_FRMW_ERR_ENV_ANCHOR_NOT_LOCKED        PRVAPIBASE + 80
#define ODPP_FRMW_ERR_PARAM_VAL_NO_LENGTH          PRVAPIBASE + 81
#define ODPP_FRMW_ERR_COL_NAME_NO_LENGTH           PRVAPIBASE + 82
#define ODPP_FRMW_ERR_COLNAME_W_MALLOC_FAILED      PRVAPIBASE + 83
#define ODPP_FRMW_ERR_COLNAME_A_MALLOC_FAILED      PRVAPIBASE + 84
#define ODPP_FRMW_ERR_PRV_NAME_MALLOC_FAILED       PRVAPIBASE + 85
#define ODPP_FRMW_ERR_PRV_DESC_MALLOC_FAILED       PRVAPIBASE + 86
#define VACANT_ENTRY                               PRVAPIBASE + 87
#define ODPP_FRMW_ERR_PARAM_A_VAL_MALLOC_FAILED    PRVAPIBASE + 88
#define ODPP_FRMW_ERR_SRCCOLS_NAME_TEMP_BUF_MALLOC_FAILED   PRVAPIBASE + 89
#define ODPP_FRMW_ERR_DUP_FLD_DEF_FAILED           PRVAPIBASE + 90
#define ODPP_FRMW_ERR_SRV_PRV_PATH_MALLOC_FAILED   PRVAPIBASE + 91
#define ODPP_FRMW_ERR_SRV_PRV_PATH_CNV_FAILED      PRVAPIBASE + 92
#define ODPP_FRMW_ERR_ERR_FILE_PATH_CONV_FAILED    PRVAPIBASE + 93
#define ODPP_FRMW_INFO_NO_COL_NAME                 PRVAPIBASE + 94
#define ODPP_FRMW_ERR_NO_STRUCT_VER                PRVAPIBASE + 95
#define ODPP_FRMW_ERR_ITOX_COLNAME_A_MALLOC_FAILED PRVAPIBASE + 96
#define ODPP_FRMW_ERR_ITOX_COLNAME_W_MALLOC_FAILED PRVAPIBASE + 97
#define ODPP_FRMW_ERR_ITOX_FLDDEF_MALLOC_FAILED    PRVAPIBASE + 98
#define ODPP_FRMW_ERR_ITOX_SRCCOL_MALLOC_FAILED    PRVAPIBASE + 99
#define ODPP_FRMW_ERR_BLK_X_MALLOC_FAILED          PRVAPIBASE + 100
#define ODPP_FRMW_ERR_ITOX_PARAMDEF_MALLOC_FAILED  PRVAPIBASE + 101
#define ODPP_FRMW_ERR_SVCDEF_X_MALLOC_FAILED       PRVAPIBASE + 102
#define ODPP_FRMW_ERR_FRMW_NOT_INITIALIZED         PRVAPIBASE + 103
#define ODPP_FRMW_ERR_GLOBAL_LOCK_FAILED           PRVAPIBASE + 104
#define ODPP_FRMW_ERR_BUFFER_MALLOC_FAILED         PRVAPIBASE + 105 //106
#define ODPP_FRMW_ERR_BUFFER_INVALID_LENGTH        PRVAPIBASE + 106 //107
#define ODPP_FRMW_ERR_GLOBAL_UNLOCK_FAILED         PRVAPIBASE + 107 //108
#define ODPP_FRMW_ERR_INVALID_LIB_PATHA_BUFFER_SIZE PRVAPIBASE + 108 //109
#define ODPP_FRWM_ERR_LIBPATH_MALLOC_FAILED         PRVAPIBASE + 109 //110
#define ODPP_FRMW_ERR_INVALID_LIB_PATHW_BUFFER_SIZE PRVAPIBASE + 110 //111
#define ODPP_FRMW_ERR_DP_NOT_LICENSED               PRVAPIBASE + 112 //113
// 2015/05/15, takahak, WI 58856
#define ODPP_FRMW_INFO_SOURCE_SPACES                PRVAPIBASE + 113 //114 
#define ODPP_FRMW_ERR_WRITING_TRIALLICFILE          PRVAPIBASE + 114 //115
#define ODPP_FRMW_ERR_INVALID_TRIALLICFILE          PRVAPIBASE + 115 //116
#define ODPP_FRMW_ERR_DP_LICENSE_INVALID            PRVAPIBASE + 116 //117
#define ODPP_FRMW_ERR_MSGS_OUT_OF_ORDER             PRVAPIBASE + 118 //119


/*=======================================================
   OS specific Library error codes
=======================================================*/
/* Range 0x00000501 to 0x00000600 i.e. total of 255 error codes*/
#define OSLIBBASE                                  0x00000501  //1281

//#define ODPP_OS_LIB_INIT_FAILED                    OSLIBBASE + 0
#define ODPP_OS_LIB_LOAD_FAILED                    OSLIBBASE + 1  //1282
#define ODPP_OS_LIB_UNLOAD_FAILED                  OSLIBBASE + 2  //1283
#define ODPP_OS_LIB_GETPROC_FAILED                 OSLIBBASE + 3  //1284
#define ODPP_OS_LIB_INVALID_LIB_HANDLE             OSLIBBASE + 4  //1285
#define ODPP_OS_LIB_ERR_FILE_NO_PERM               OSLIBBASE + 5  //1286
#define ODPP_OS_LIB_ERR_INVALID_FILE               OSLIBBASE + 6  //1287
#define ODPP_OS_LIB_ERR_TOMANYLINKS                OSLIBBASE + 7  //1288
#define ODPP_OS_LIB_ERR_NO_MEMORY                  OSLIBBASE + 8  //1289
#define ODPP_OS_LIB_ERR_FILE_OPEN                  OSLIBBASE + 9  //1290
#define ODPP_OS_LIB_ERR_PATH_COMP_TOOLONG          OSLIBBASE + 10 //1291
#define ODPP_OS_LIB_ERR_PATH_NOT_EXIST             OSLIBBASE + 11 //1292
#define ODPP_OS_LIB_ERR_PROCNAME_NOTFOUND          OSLIBBASE + 12 //1293

#define MUTEX_BASE                                 13
#define ODPP_OS_LIB_MUTEX_CREATE_FAILED            OSLIBBASE + MUTEX_BASE + 0 //OSLIBBASE + 13: 1294
#define ODPP_OS_LIB_MUTEX_LOCK_FAILED              OSLIBBASE + MUTEX_BASE + 1 //OSLIBBASE + 14: 1295
#define ODPP_OS_LIB_MUTEX_UNLOCK_FAILED            OSLIBBASE + MUTEX_BASE + 2 //OSLIBBASE + 15: 1296
#define ODPP_OS_LIB_MUTEX_NOT_ENOUGH_RESORCES      OSLIBBASE + MUTEX_BASE + 3 //OSLIBBASE + 16: 1297
#define ODPP_OS_LIB_MUTEX_NOT_ENOUGH_MEMORY        OSLIBBASE + MUTEX_BASE + 4 //OSLIBBASE + 17: 1298
#define ODPP_OS_LIB_MUTEX_NO_PRIVILEGE             OSLIBBASE + MUTEX_BASE + 5 //OSLIBBASE + 18: 1299
#define ODPP_OS_LIB_MUTEX_ALREADY_INITIALIZED      OSLIBBASE + MUTEX_BASE + 6 //OSLIBBASE + 19: 1300
#define ODPP_OS_LIB_MUTEX_INVALID_ATTR_VALUE       OSLIBBASE + MUTEX_BASE + 7 //OSLIBBASE + 20: 1301
#define ODPP_OS_LIB_MUTEX_MAX_LOCKED               OSLIBBASE + MUTEX_BASE + 8 //OSLIBBASE + 21: 1302
#define ODPP_OS_LIB_MUTEX_OWNED_BY_CURTHREAD       OSLIBBASE + MUTEX_BASE + 9 //OSLIBBASE + 22: 1303
#define ODPP_OS_LIB_MUTEX_SETATTR_FAILED           OSLIBBASE + MUTEX_BASE + 10//OSLIBBASE + 23: 1304
#define ODPP_OS_LIB_MUTEX_INVALID_MUTEX            OSLIBBASE + MUTEX_BASE + 11//OSLIBBASE + 24: 1305
#define ODPP_OS_LIB_MUTEX_IS_LOCKED                OSLIBBASE + MUTEX_BASE + 12//OSLIBBASE + 25: 1306
#define ODPP_OS_LIB_MUTEX_DESTROY_FAILED           OSLIBBASE + MUTEX_BASE + 13 //OSLIBBASE + 26: 1307



#define ODPP_OS_LIB_ERR_NULL_LIBPATH_BUFFER                       OSLIBBASE + 27 //OSLIBBASE + 27: 1308
#define ODPP_OS_LIB_ERR_GETLIBPATH_MALLOC_FAILED                  OSLIBBASE + 28 //OSLIBBASE + 28: 1309
#define ODPP_OS_LIB_ERR_LOADQUERY_FAILED_WITH_EINVAL              OSLIBBASE + 29 //OSLIBBASE + 29: 1310
#define ODPP_OS_LIB_ERR_LOADQUERY_FAILED_WITH_EFAULT              OSLIBBASE + 30 //OSLIBBASE + 30: 1311
#define ODPP_OS_LIB_ERR_INSUFFICIENT_LIBPATH_BUF_LEN              OSLIBBASE + 31 //OSLIBBASE + 31: 1312
#define ODPP_OS_LIB_ERR_INVALID_LIBPATH_BUFFER_SIZE               OSLIBBASE + 32 //OSLIBBASE + 32: 1313
#define ODPP_OS_LIB_ERR_GETMODULEFILENAME_FAILED                  OSLIBBASE + 33 //OSLIBBASE + 33: 1314
#define ODPP_OS_LIB_ERR_DLADDR_FAILED                             OSLIBBASE + 34 //OSLIBBASE + 34: 1315
#define ODPP_OS_LIB_ERR_FAILED_TO_GET_LIBPATH                     OSLIBBASE + 35 //OSLIBBASE + 35: 1316
#define ODPP_OS_LIB_NULL_LIBNAME                                  OSLIBBASE + 36 //OSLIBBASE + 36: 1317
#define ODPP_OS_LIB_ERR_LIBPATH_MALLOC_FAILED                     OSLIBBASE + 37 //OSLIBBASE + 37: 1318
#define ODPP_OS_LIB_ERR_SECURE_RANDOM_FAILED                      OSLIBBASE + 38 //OSLIBBASE + 38: 1319

/*=======================================================
   List related error codes
=======================================================*/
/* Range 0x00000601 to 0x00000620 */
#define LISTBASE                                   0x00000601 //1537

//#define ODPP_LIST_ERR_INIT_FAILED                  LISTBASE + 0
#define ODPP_LIST_ERR_ADD_NODE_MALLOC_FAILED       LISTBASE + 1
#define ODPP_LIST_ERR_NULL_INITBLK                 LISTBASE + 2
#define ODPP_LIST_ERR_ADDNODE_NULL_PRV_NAME        LISTBASE + 4
#define ODPP_LIST_ERR_ADDNODE_INVALID_THID         LISTBASE + 5
#define ODPP_LIST_INFO_PRV_NODE_NOTFOUND           LISTBASE + 6
#define ODPP_LIST_ERR_ADD_NODEBLK_MALLOC_FAILED    LISTBASE + 7
#define ODPP_LIST_WARN_NODES_NOT_EMPTY             LISTBASE + 8

/*=======================================================
   Thread Block related error codes
=======================================================*/
/* Range 0x00000621 to 0x00000634 i.e. 20 Error codes */
#define THBLKBASE                                  0x00000621
#define ODPP_THBLK_WARN_TH_BLK_NOT_EMPTY           THBLKBASE + 0
#define ODPP_THBLK_ERR_BLK_EXISTING                THBLKBASE + 1
#define ODPP_THBLK_ERR_THBLK_MALLOC_FAILED         THBLKBASE + 2

/*=======================================================
   Environment Module Related error codes
=======================================================*/
/* Range 0x00000635 (1589) to 0x00000648 (1608) i.e. 20 Error codes */
#define ENVBASE                                    0x00000635  //1589
#define ODPP_ENV_ERR_THBLK_MALLOC_FAILED           ENVBASE + 0
#define ODPP_ENV_ERR_FAILED_TERM_ANC_LOCKED        ENVBASE + 1
#define ODPP_ENV_ERR_FAILED_TERM_ICU_NOT_CLEANED   ENVBASE + 2
#define ODPP_ENV_ERR_ANC_ALREADY_UNLOCKED          ENVBASE + 3
#define ODPP_ENV_ERR_ANC_NOT_LOCKED_BY_THIS_THREAD ENVBASE + 4

/*=======================================================
   Data Conversion Module Related error codes
=======================================================*/
/* Range 0x00000649 (1609) to 0x0000067A (1658) i.e. 50 Error codes */
#define DATACNVBASE                                0x00000649  //1609
#define ODPP_DATACNV_ERR_DATA_TRUNCATED            DATACNVBASE + 0 //1609
#define ODPP_DATACNV_ERR_GET_ICU_CONV_FAILED       DATACNVBASE + 1 //1610
#define ODPP_DATACNV_ERR_MALLOC_FAILED             DATACNVBASE + 2 //1611
#define ODPP_DATACNV_ERR_INVALID_DIGIT_IN_NUMSTR   DATACNVBASE + 3 //1612
#define ODPP_DATACNV_ERR_FLOAT_VALUE_OUT_OF_RANGE  DATACNVBASE + 4 //1613
#define ODPP_DATACNV_ERR_INVALID_HOUR              DATACNVBASE + 5 //1614
#define ODPP_DATACNV_ERR_INVALID_DATA              DATACNVBASE + 6 //1615
#define ODPP_DATACNV_ERR_INSUFFICIENT_BUFFER_LEN   DATACNVBASE + 7 //1616
#define ODPP_DATACNV_ERR_DOUBLE_VALUE_OUT_OF_RANGE DATACNVBASE + 8 //1617

/*=======================================================
   CCN error codes
  ======================================================*/
/* Range 0x00001000 to 0x000010FF   -> i.e. 256 error codes */
#define CCNBASE                                    0x00001000
#define ODPP_CCN_ERR_DATATYPE_NOTSUPPORTED         CCNBASE + 0
#define ODPP_CCN_ERR_CCNCTRLBLK_MALLOC_FAILED      CCNBASE + 1
#define ODPP_CCN_ERR_ROWSET_EMPTY                  CCNBASE + 5
#define ODPP_CCN_ERR_NO_SOURCE_DATA                CCNBASE + 6
#define ODPP_CCN_ERR_NO_CCNCTRLBLK                 CCNBASE + 7
#define ODPP_CCN_ERR_INVALID_METHOD                CCNBASE + 8
#define ODPP_CCN_ERR_PREFIXTBL_MALLOC_FAILED       CCNBASE + 10
#define ODPP_CCN_ERR_INVALID_SRCCOL_INDEX          CCNBASE + 11
#define ODPP_CCN_ERR_INVALID_COLLENGTH_FOR_DEC370  CCNBASE + 12
#define ODPP_CCN_ERR_HEAP_CREATE_FAILED            CCNBASE + 13
#define ODPP_CCN_ERR_HEAP_DISCARD_FAILED           CCNBASE + 14

#define ODPP_CCN_INFO_SRVMETHOD                    CCNBASE + 20

/* CCN Column/Row Specific errors */
#define ODPP_CCN_ERR_NON_NUMERIC_VALUE             CCNBASE + 40
#define ODPP_CCN_ERR_INVALID_IN_LENGTH             CCNBASE + 41
#define ODPP_CCN_ERR_INVALID_CHK_DIGIT             CCNBASE + 42
#define ODPP_CCN_ERR_IN_LENGTH_NE_EXPECTED_LEN     CCNBASE + 43
#define ODPP_CCN_ERR_NULL_DST_BUF                  CCNBASE + 44
#define ODPP_CCN_ERR_CONVERSION_SRC                CCNBASE + 45
#define ODPP_CCN_ERR_CONVERSION_DST                CCNBASE + 46
#define ODPP_CCN_INFO_SOURCE_SPACES                CCNBASE + 47
#define ODPP_CCN_INFO_SRC_NULL_DST_SETTONULL       CCNBASE + 48
//#define This is now an available slot - no longer used           CCNBASE + 49
#define ODPP_CCN_ERR_INVALID_CCN_FLAGS             CCNBASE + 50
#define ODPP_CCN_ERR_FAILED_TO_MASK                CCNBASE + 51
#define ODPP_CCN_ERR_SOURCE_ALLZEROS               CCNBASE + 52

/*=======================================================
      NID error codes
=======================================================*/
/* Range 0x00001100 to 0x000014FF   -> i.e. 1024 error codes */
#define NIDBASE                                    0x00001100
#define ODPP_NID_ERR_NIDCTRLBLK_MALLOC_FAILED      NIDBASE + 0 //4352
#define ODPP_NID_ERR_NO_COUNTRY_TO_MASK            NIDBASE + 1
#define ODPP_NID_ERR_DATATYPE_NOTSUPPORTED         NIDBASE + 2
#define ODPP_NID_ERR_NO_NIDCTRLBLK                 NIDBASE + 3
#define ODPP_NID_ERR_NO_SOURCE_DATA                NIDBASE + 4
#define ODPP_NID_ERR_INVALID_METHOD                NIDBASE + 5
#define ODPP_NID_ERR_ROWSET_EMPTY                  NIDBASE + 6
//#define ODPP_NID_ERR_NO_SEP                        NIDBASE + 7
#define ODPP_NID_ERR_INVALID_SEP                   NIDBASE + 8
#define ODPP_NID_INFO_NO_PARTS                     NIDBASE + 9
#define ODPP_NID_ERR_INVALID_PARTS                 NIDBASE + 10
#define ODPP_NID_ERR_INVALID_SRCCOL_INDEX          NIDBASE + 11
#define ODPP_NID_ERR_COUNTRY_ALGO_NOT_INIT         NIDBASE + 12
#define ODPP_NID_ERR_HEAP_CREATE_FAILED            NIDBASE + 13
#define ODPP_NID_ERR_HEAP_DISCARD_FAILED           NIDBASE + 14

#define ODPP_NID_INFO_SRVMETHOD                    NIDBASE + 48
#define ODPP_NID_INFO_IGNINVALID                   NIDBASE + 49

/* NID Column/Row Specific errors */
#define ODPP_NID_ERR_NULL_DST_BUF                  NIDBASE + 50 //4402
#define ODPP_NID_INFO_SOURCE_SPACES                NIDBASE + 51 //4403
#define ODPP_NID_ERR_CONVERSION_SRC                NIDBASE + 52 //4404
#define ODPP_NID_ERR_INVALID_IN_LENGTH             NIDBASE + 53 //4405
#define ODPP_NID_ERR_INVALID_SEP_INSOURCE          NIDBASE + 54 //4406
#define ODPP_NID_ERR_INVALID_SOURCE_VALUE          NIDBASE + 55 //4407
#define ODPP_NID_INFO_SRC_NULL_DST_SETTONULL       NIDBASE + 56 //4408
#define ODPP_NID_ERR_GETCOUNTRY_FAILED             NIDBASE + 57 //4409
#define ODPP_NID_ERR_CONVERSION_DST                NIDBASE + 58
#define ODPP_NID_ERR_CNV_TO_ZERO_LENGTH            NIDBASE + 59
#define ODPP_NID_ERR_INVALID_COLLENGTH_FOR_DEC370  NIDBASE + 60
#define ODPP_NID_ERR_CNTRY_MASKING_FAILED          NIDBASE + 61

/* FR specific codes */
#define ODPP_NID_ERR_FR_INITCOUNTRY_FAILED         NIDBASE + 101
#define ODPP_NID_ERR_FR_INVALID_SEX                NIDBASE + 102
#define ODPP_NID_ERR_FR_INVALID_DEPT               NIDBASE + 103
#define ODPP_NID_ERR_FR_INVALID_MONTH              NIDBASE + 104
#define ODPP_NID_ERR_FR_INVALID_COMMUNE            NIDBASE + 105
#define ODPP_NID_ERR_FR_INVALID_CHECKDIGIT         NIDBASE + 106

/* ES specific codes */
#define ODPP_NID_ERR_ES_INITCOUNTRY_FAILED         NIDBASE + 126
#define ODPP_NID_ERR_ES_INVALID_SUFFIX             NIDBASE + 127

/* IT specific codes */
#define ODPP_NID_ERR_IT_INITCOUNTRY_FAILED         NIDBASE + 151
#define ODPP_NID_ERR_IT_INVALID_NAME_IN_SRC        NIDBASE + 152
#define ODPP_NID_ERR_IT_INVALID_REPLCMNT_CHAR      NIDBASE + 153
#define ODPP_NID_ERR_IT_INVALID_CHAR_IN_SRC        NIDBASE + 154
#define ODPP_NID_ERR_IT_INVALID_FAMILY_NAME        NIDBASE + 155
#define ODPP_NID_ERR_IT_INVALID_FIRST_NAME         NIDBASE + 156
#define ODPP_NID_ERR_IT_INVALID_BIRTH_DATE         NIDBASE + 157 //4509 (119D)
#define ODPP_NID_ERR_IT_INVALID_REGION_CODE        NIDBASE + 158
#define ODPP_NID_ERR_IT_INVALID_CHECKDIGIT         NIDBASE + 159
#define ODPP_NID_ERR_IT_MASK_NAME                  NIDBASE + 160

/* UK specific codes */
#define ODPP_NID_ERR_UK_INITCOUNTRY_FAILED         NIDBASE + 176
#define ODPP_NID_ERR_UK_INVALID_FLAGS              NIDBASE + 177
#define ODPP_NID_ERR_UK_INVALID_PREFIX             NIDBASE + 178 //4530
#define ODPP_NID_ERR_UK_INVALID_NUMBER             NIDBASE + 179
#define ODPP_NID_ERR_UK_INVALID_SUFFIX             NIDBASE + 180
#define ODPP_NID_ERR_UK_INVALID_DEST_FORMAT        NIDBASE + 181
// 2014/02/14, takahak, WI 61338
#define ODPP_NID_ERR_UK_UNSUPPORTED_FORMAT         NIDBASE + 182      // d61338A

/* US specific codes */
#define ODPP_NID_ERR_US_INITCOUNTRY_FAILED         NIDBASE + 201 //4553
#define ODPP_NID_ERR_US_INVALIDAREA                NIDBASE + 202 //4554
#define ODPP_NID_ERR_US_UNUSEDAREA                 NIDBASE + 203 //4555
#define ODPP_NID_ERR_US_INVALIDGROUP               NIDBASE + 204 //4556
#define ODPP_NID_ERR_US_INVALIDSERIAL              NIDBASE + 205 //4557
#define ODPP_NID_ERR_US_INVALID_FLAGS              NIDBASE + 206 //4558

/* CA specific codes */
#define ODPP_NID_ERR_CA_INITCOUNTRY_FAILED         NIDBASE + 226
#define ODPP_NID_ERR_CA_INVALID_REGION             NIDBASE + 227


/*=======================================================
   EML error codes
  ======================================================*/
/* Range 0x00001500 to 0x000015FF   -> i.e. 256 error codes */
#define EMLBASE                                    0x00001500
#define ODPP_EML_ERR_EMLCTRLBLK_MALLOC_FAILED      EMLBASE + 0
//#define ODPP_EML_ERR_INVALID_EML_FLAGS             EMLBASE + 1
#define ODPP_EML_ERR_INCOMPATIBLE_EML_FLAGS        EMLBASE + 2
#define ODPP_EML_ERR_NO_EMLCTRLBLK                 EMLBASE + 3
#define ODPP_EML_ERR_ROWSET_EMPTY                  EMLBASE + 4
#define ODPP_EML_ERR_NO_SOURCE_DATA                EMLBASE + 5
#define ODPP_EML_ERR_INCOMPATIBLE_OPERANDS         EMLBASE + 6
#define ODPP_EML_ERR_INVALID_NAME1COL              EMLBASE + 7
#define ODPP_EML_ERR_INVALID_NAME2COL              EMLBASE + 8
//#define ODPP_EML_ERR_NO_NAME1COL_DATA              EMLBASE + 9
//#define ODPP_EML_ERR_NO_NAME2COL_DATA              EMLBASE + 10
#define ODPP_EML_ERR_USER_LITERAL_TOOLONG          EMLBASE + 11
#define ODPP_EML_ERR_DOMAIN_LITERAL_TOOLONG        EMLBASE + 12
#define ODPP_EML_ERR_SEED_VALUE_TOOLONG            EMLBASE + 13
#define ODPP_EML_INFO_SRVMETHOD                    EMLBASE + 14
#define ODPP_EML_ERR_INVALID_METHOD                EMLBASE + 15
#define ODPP_EML_ERR_DATATYPE_NOTSUPPORTED         EMLBASE + 16
#define ODPP_EML_ERR_INVALID_SRCCOL_INDEX          EMLBASE + 17
/* EML Column/Row Specific errors */
#define ODPP_EML_ERR_NULL_DST_BUF                  EMLBASE + 40
#define ODPP_EML_INFO_SRC_NULL_DST_SETTONULL        EMLBASE + 41
#define ODPP_EML_INFO_SOURCE_SPACES                EMLBASE + 42
#define ODPP_EML_ERR_SOURCE_NO_AT_THE_RATE         EMLBASE + 43
#define ODPP_EML_ERR_CONVERSION_SRC                EMLBASE + 44
#define ODPP_EML_ERR_GET_SEQ_FAILED                EMLBASE + 45
#define ODPP_EML_ERR_DOMAIN_NAME_TOOLONG           EMLBASE + 46
#define ODPP_EML_ERR_CONVERSION_DST                EMLBASE + 47
#define ODPP_EML_ERR_NO_DOT_IN_EMAIL               EMLBASE + 48
#define ODPP_EML_ERR_FAILED_GETNAME1COL            EMLBASE + 49
#define ODPP_EML_ERR_FAILED_GETNAME1DATACOL        EMLBASE + 50
#define ODPP_EML_ERR_FAILED_GETNAME2DATACOL        EMLBASE + 51
#define ODPP_EML_ERR_INVALID_NAMECOL               EMLBASE + 52  //5428
#define ODPP_EML_ERR_NULL_NAME1COL                 EMLBASE + 53  //5429
#define ODPP_EML_ERR_NULL_NAME2COL                 EMLBASE + 54  //5430
#define ODPP_EML_ERR_SOURCE_MULTIPLE_AT_THE_RATE   EMLBASE + 55  //5431
#define ODPP_EML_ERR_MULTIPLE_SEED_OPERANDS        EMLBASE + 56  //5432
#define ODPP_EML_ERR_HASHSRC_CONVERT_FAILED        EMLBASE + 57  //5433
#define ODPP_EML_ERR_INVALID_SEEDVAL_FOR_ALGO_SHA256  EMLBASE + 58 //5434
#define ODPP_EML_ERR_HASHLIBAPI_MALLOC_FAILED      EMLBASE + 59 //5435
#define ODPP_EML_ERR_SEED_HMAC_ALGO_NATIVE         EMLBASE + 60 //5436
#define ODPP_EML_ERR_INCOMPATIBLE_PARMS_MTD_RND_FLG_HASH_ENABLED  EMLBASE + 61 //5437
#define ODPP_EML_ERR_INCOMPATIBLE_PARMS_MTD_RND_HASHDOMAIN     EMLBASE + 62 //5438
#define ODPP_EML_ERR_INCOMPATIBLE_PARMS_MTD_RND_LITDOMAIN      EMLBASE + 63 //5439
#define ODPP_EML_ERR_INCOMPATIBLE_PARMS_MTD_RND_HASHSEED       EMLBASE + 64 //5440
#define ODPP_EML_ERR_INCOMPATIBLE_PARMS_MTD_RND_HASHALGO       EMLBASE + 65 //5441
#define ODPP_EML_ERR_HEAP_CREATE_FAILED            EMLBASE + 66 //5442
#define ODPP_EML_ERR_HEAP_DISCARD_FAILED           EMLBASE + 67 //5443 
#define ODPP_EML_ERR_SOURCE_NO_CHAR_BEFORE_OR_AFTER_ASTER EMLBASE + 68 //5444
#define ODPP_EML_ERR_NO_DOMAIN                     EMLBASE + 69 //5445

/*=======================================================
   COL error codes
  ======================================================*/
/* Range 0x00001600 to 0x000016FF   -> i.e. 256 error codes */
#define COLBASE                                    0x00001600
#define ODPP_COL_ERR_COLCTRLBLK_MALLOC_FAILED      COLBASE +  0 //5632
#define ODPP_COL_ERR_INVALID_METHOD                COLBASE +  1 //5633
#define ODPP_COL_ERR_UNSUPPORTED_DATATYPE          COLBASE +  2 //5634
#define ODPP_COL_ERR_METHOD_ALREADY_SPECIFIED      COLBASE +  3
#define ODPP_COL_ERR_MASK_ALREADY_SPECIFIED        COLBASE +  4
#define ODPP_COL_ERR_SEED_ALREADY_SPECIFIED        COLBASE +  6
#define ODPP_COL_ERR_COPY_ALREADY_SPECIFIED        COLBASE +  7
#define ODPP_COL_ERR_LENGTH_ALREADY_SPECIFIED      COLBASE +  8
#define ODPP_COL_ERR_NUM_ALREADY_SPECIFIED         COLBASE +  9
#define ODPP_COL_ERR_TRIM_ALREADY_SPECIFIED        COLBASE + 10
#define ODPP_COL_ERR_SEED_LITERAL_MALFORMED        COLBASE + 12
#define ODPP_COL_ERR_SEED_VAR_NOT_FOUND            COLBASE + 13
#define ODPP_COL_ERR_COPY_UNBALANCED_PARENS        COLBASE + 14
#define ODPP_COL_ERR_COPY_MISSING_COMMA            COLBASE + 15
#define ODPP_COL_ERR_COPY_UNBALANCED_QUOTES        COLBASE + 16
#define ODPP_COL_ERR_COPY_START_INVALID            COLBASE + 17
#define ODPP_COL_ERR_COPY_LENGTH_INVALID           COLBASE + 18
#define ODPP_COL_ERR_COPY_OVERLAP                  COLBASE + 19
#define ODPP_COL_ERR_COPY_NULL_LITERAL             COLBASE + 20
#define ODPP_COL_INFO_COPY_LITERAL_TOO_LONG        COLBASE + 21
#define ODPP_COL_ERR_COPY_TOO_LONG                 COLBASE + 22
#define ODPP_COL_ERR_LENGTH_INVALID_WITH_UNIQUE    COLBASE + 23
#define ODPP_COL_ERR_MASK_OPTION_INVALID           COLBASE + 24
#define ODPP_COL_ERR_MASK_NOT_SPECIFIED            COLBASE + 25
#define ODPP_COL_ERR_ROWSET_EMPTY                  COLBASE + 26
#define ODPP_COL_ERR_NO_SOURCE_DATA                COLBASE + 27
#define ODPP_COL_ERR_NULL_DST_BUF                  COLBASE + 28
#define ODPP_COL_INFO_SRC_NULL_DST_SETTONULL       COLBASE + 29 //5661
#define ODPP_COL_ERR_NO_ANCHORBLK                  COLBASE + 30
#define ODPP_COL_INFO_SOURCE_SPACES                COLBASE + 31
#define ODPP_COL_ERR_TRIM_INVALID_FORMAT           COLBASE + 32
#define ODPP_COL_ERR_TRIM_ULERR                    COLBASE + 33
#define ODPP_COL_ERR_BINARY_ALREADY_SPECIFIED      COLBASE + 34
#define ODPP_COL_ERR_BINARY_INVALID_WITH_LENGTH    COLBASE + 35
#define ODPP_COL_ERR_BINARY_INVALID_WITH_COPY      COLBASE + 36
#define ODPP_COL_ERR_BINARY_INVALID_WITH_TRIM      COLBASE + 37
#define ODPP_COL_ERR_BINARY_INVALID_WITH_NUM       COLBASE + 38
#define ODPP_COL_ERR_INVALID_SRCCOL_INDEX          COLBASE + 39
#define ODPP_COL_ERR_SEEDSTR_MALLOC_FAILED         COLBASE + 40
#define ODPP_COL_ERR_CNV_SEED_STRING               COLBASE + 41

#define ODPP_COL_ERR_WHENMATCH_INVALID_PARAM_VAL_SUBTYPE  COLBASE + 42 //5674
#define ODPP_COL_ERR_INVALID_ITERATION_VALUE       COLBASE + 43 //5675
#define ODPP_COL_ERR_INVALID_KEY_LEN               COLBASE + 44 //5676
#define ODPP_COL_ERR_KEY_LITERAL_MALLOC_FAILED     COLBASE + 45 //5677
#define ODPP_COL_ERR_CNV_KEY_LITERAL               COLBASE + 46 //5678
#define ODPP_COL_ERR_WHENMATCH_UNBALANCED_PARENS   COLBASE + 47 //5679
#define ODPP_COL_ERR_WHENMATCH_MISSING_COMMA       COLBASE + 48 //5680
#define ODPP_COL_ERR_WHENMATCH_UNBALANCED_QUOTES   COLBASE + 49 //5681
#define ODPP_COL_ERR_WHENMATCH_PARAM_VAL_NULL      COLBASE + 50 //5682
#define ODPP_COL_ERR_WHENMATCH_BLK_MALLOC_FAILED    COLBASE + 51 //5683
#define ODPP_COL_ERR_WHENMATCH_LITSTR_MALLOC_FAILED COLBASE + 52 //5684
#define ODPP_COL_ERR_WHENMATCH_WIDE_TO_INT_CNV_FAILED   COLBASE + 53 //5685
#define ODPP_COL_ERR_WHENMATCH_NO_PARENS            COLBASE + 54 //5686
#define ODPP_COL_ERR_WHENMATCH_INVALID_SYNTAX       COLBASE + 55 //5687
#define ODPP_COL_ERR_GET_ICU_CONV_FAILED            COLBASE + 56 //5688
#define ODPP_COL_ERR_GET_UNICODE_SET_FAILED         COLBASE + 57 //5689
#define ODPP_COL_ERR_CHARCLASS_MALLOC_FAILED        COLBASE + 58 //5690
#define ODPP_COL_ERR_CHAR_NOTFOUND_IN_CHARCLASS     COLBASE + 59 //5691
#define ODPP_COL_ERR_INCOMPATIBLE_PARAMS_KEY_ALGO_DEFAULT         COLBASE + 60 //5692
#define ODPP_COL_ERR_INCOMPATIBLE_PARAMS_ITERATIONS_ALGO_DEFAULT  COLBASE + 61 //5693
#define ODPP_COL_ERR_INCOMPATIBLE_PARAMS_TWEAKS_ALGO_DEFAULT      COLBASE + 62 //5694
#define ODPP_COL_ERR_SPE_API_MALLOC_FAILED                        COLBASE + 63 //5695
#define ODPP_COL_ERR_INCOMPATIBLE_PARAMS_SEED_ALGO_FPE            COLBASE + 64 //5696
#define ODPP_COL_ERR_ALGO_FPE_REQD_PARM_KEY_NOTFOUND              COLBASE + 65 //5697
#define ODPP_COL_ERR_SPE_ENCRYPT1_FAILED                          COLBASE + 66 //5698
#define ODPP_COL_ERR_SPE_BUFFER_MALLOC_FAILED                     COLBASE + 67 //5699
#define ODPP_COL_ERR_TWEAKS_BUFFER_MALLOC_FAILED                  COLBASE + 68 //5700
#define ODPP_COL_ERR_KEY_ENVVAR_CONVERT_FAILED                    COLBASE + 69 //5701
#define ODPP_COL_ERR_PREFIX_EXCEED_MAX_VALUE_RANGE                COLBASE + 70 //5702
#define ODPP_COL_ERR_WHENMATCH_INVALID_SEQ_OR_RAND_RANGE          COLBASE + 71 //5703
#define ODPP_COL_ERR_GET_KEY_ENVVAL_FAILED                        COLBASE + 72 //5704
#define ODPP_COL_ERR_WHENMATCH_INVALID_OVERLAY_SPECIFICATION      COLBASE + 73 //5705
#define ODPP_COL_ERR_WHENMATCH_INSUFFICIENT_SRCBUF                COLBASE + 74 //5706
#define ODPP_COL_ERR_WHENMATCH_TEMP_BUF_MALLOC_FAILED             COLBASE + 75 //5707
#define ODPP_COL_ERR_WHENMATCH_LITERAL_LEN_INVALID                COLBASE + 76 //5708
#define ODPP_COL_ERR_WHENMATCH_LITERAL_NONNUMERIC                 COLBASE + 77 //5709
#define ODPP_COL_ERR_SUFFIX_EXCEED_MAX_VALUE_RANGE                COLBASE + 78 //5710
#define ODPP_COL_ERR_WHENMATCH_OVERLAY_START_OUT_OF_RANGE         COLBASE + 79 //5711
#define ODPP_COL_ERR_OVERLAY_EXCEED_MAX_VALUE_RANGE               COLBASE + 80 //5712
#define ODPP_COL_ERR_SPE_STATE_MALLOC_FAILED                      COLBASE + 81 //5713
#define ODPP_COL_ERR_SPE_INIT_FAILED                              COLBASE + 82 //5714
#define ODPP_COL_ERR_SPE_ENCRYPT_FAILED                           COLBASE + 83 //5715
#define ODPP_COL_ERR_EXIT_NOT_FOUND                               COLBASE + 84 //5716
#define ODPP_COL_ERR_EXIT_FUNC_GETLANGCUSTOM_NOT_FOUND            COLBASE + 85 //5717
#define ODPP_COL_ERR_CNV_EXITNAME                                 COLBASE + 86 //5718
#define ODPP_COL_ERR_HEAP_CREATE_FAILED                           COLBASE + 87 //5719
#define ODPP_COL_ERR_HEAP_DISCARD_FAILED                          COLBASE + 88 //5720
#define ODPP_COL_ERR_MALLOC_FAILED                                COLBASE + 89 //5721
#define ODPP_COL_ERR_INVALID_LANG                                 COLBASE + 90 //5722


/*=======================================================
   LOOKUP error codes
  ======================================================*/
/* Range 0x00001700 to 0x000017FF   -> i.e. 256 error codes */
#define LKPBASE                                          0x00001700
#define ODPP_LKP_ERR_NULL_LDSFLDDEF                      LKPBASE +  0  // 5888
#define ODPP_LKP_ERR_NULL_SRCFLDDEF                      LKPBASE +  1  // 5889
#define ODPP_LKP_ERR_SRC_DATATYPE_NOTSUPPORTED           LKPBASE +  2  // 5890
#define ODPP_LKP_ERR_LDS_DATATYPE_NOTSUPPORTED           LKPBASE +  3  // 5891
#define ODPP_LKP_ERR_LDS_FLD_NULL_CNV_BLK                LKPBASE +  4  // 5892
#define ODPP_LKP_ERR_LKPCTRLBLK_MALLOC_FAILED            LKPBASE +  5  // 5893
#define ODPP_LKP_ERR_INVALID_REPLACE_COLUMN              LKPBASE +  9  // 5897
#define ODPP_LKP_ERR_LDS_FLD_MALLOC_FAILED               LKPBASE +  10 // 5898
#define ODPP_LKP_ERR_LDS_FLD_DEF_MALLOC_FAILED           LKPBASE +  11 // 5899
#define ODPP_LKP_ERR_NULL_SEARCH_COLS                    LKPBASE +  13 // 5901
#define ODPP_LKP_ERR_NULL_REPLACE_COLS                   LKPBASE +  14 // 5902
#define ODPP_LKP_ERR_LDS_LIB_NAME_MALLOC_FAILED          LKPBASE +  19 // 5907
#define ODPP_LKP_ERR_LDS_TRIM_CHARS_MALLOC_FAILED        LKPBASE +  20 // 5908
#define ODPP_LKP_ERR_LDSLIBNAME_CONVERT_FAILED           LKPBASE +  21 // 5909
#define ODPP_LKP_ERR_NULL_LDSLIBNAME                     LKPBASE +  22 // 5910
#define ODPP_LKP_ERR_NO_LKPCTRLBLK                       LKPBASE +  23 // 5911
#define ODPP_LKP_ERR_LDS_BUF_MALLOC_FAILED               LKPBASE +  24 // 5912
#define ODPP_LKP_ERR_ROWSET_EMPTY                        LKPBASE +  25 // 5913
#define ODPP_LKP_ERR_NOT_ENOUGH_DATA_BLOCKS              LKPBASE +  26 // 5914
#define ODPP_LKP_ERR_INVALID_METHOD                      LKPBASE +  27 // 5915
#define ODPP_LKP_ERR_NO_SOURCE_COL_DATA                  LKPBASE +  28 // 5916
#define ODPP_LKP_ERR_NO_REPLACEMENT_COL_DATA             LKPBASE +  29 // 5917
#define ODPP_LKP_ERR_CONVERT_BUFFER_MALLOC_FAILED        LKPBASE +  30 // 5918
#define ODPP_LKP_ERR_PARSING_REPLACE_COLS                LKPBASE +  31 // 5919
#define ODPP_LKP_ERR_FLD_CNV_BLK_MALLOC_FAILED           LKPBASE +  32 // 5920
#define ODPP_LKP_ERR_LKP_SRC_DATA_FLD_MALLOC_FAILED      LKPBASE +  33 // 5921
#define ODPP_LKP_ERR_LKP_REP_DATA_FLD_MALLOC_FAILED      LKPBASE +  34 // 5922
#define ODPP_LKP_ERR_LKP_REP_ROW_MALLOC_FAILED           LKPBASE +  35 // 5923
#define ODPP_LKP_ERR_SRC_TO_TMP_CNV_FAILED               LKPBASE +  36 // 5924
#define ODPP_LKP_ERR_SRC_TO_LDS_CNV_FAILED               LKPBASE +  37 // 5925
#define ODPP_LKP_ERR_REP_TO_TMP_CNV_FAILED               LKPBASE +  38 // 5926
#define ODPP_LKP_ERR_REP_TO_SRC_CNV_FAILED               LKPBASE +  39 // 5927
#define ODPP_LKP_ERR_HASHSRC_CONCATENATE_FAILED          LKPBASE +  40 // 5928
#define ODPP_LKP_ERR_HASHSTRING_MALLOC_FAILED            LKPBASE +  41 // 5929
#define ODPP_LKP_ERR_TRIM_CHARS_FAILED                   LKPBASE +  42 // 5930
#define ODPP_LKP_ERR_NO_SOURCE_DATA_TO_HASH              LKPBASE +  43 // 5931
#define ODPP_LKP_ERR_FETCHING_LKPTBL_ROW_COUNT           LKPBASE +  44 // 5932
#define ODPP_LKP_ERR_LKPTBL_ROW_COUNT_MALLOC_FAILED      LKPBASE +  45 // 5933
#define ODPP_LKP_ERR_LKPTBL_SEQ_COL_MALLOC_FAILED        LKPBASE +  46 // 5934
#define ODPP_LKP_ERR_CLOSING_STATEMENT                   LKPBASE +  47 // 5935
#define ODPP_LKP_ERR_HASH_SEQ_BUF_MALLOC_FAILED          LKPBASE +  48 // 5936
#define ODPP_LKP_ERR_FMTCODES_MALLOC_FAILED              LKPBASE +  49 // 5937
#define ODPP_LKP_ERR_CACHE_BLK_MALLOC_FAILED             LKPBASE +  100 // 5988
#define ODPP_LKP_ERR_CACHE_MEM_BLK_MALLOC_FAILED         LKPBASE +  101 // 5989
#define ODPP_LKP_ERR_CACHE_MEM_BLK_BUF_MALLOC_FAILED     LKPBASE +  102 // 5990
#define ODPP_LKP_ERR_CACHE_TEMP_PATH_MALLOC_FAILED       LKPBASE +  103 // 5991
#define ODPP_LKP_ERR_CACHE_TEMP_PATH_CONVERT_FAILED      LKPBASE +  104 // 5992
#define ODPP_LKP_ERR_CACHE_TEMP_FILE_CREATE_FAILED             LKPBASE +  105
#define ODPP_LKP_ERR_CACHE_TEMP_MEM_BLK_BUF_MALLOC_FAILED      LKPBASE +  106
#define ODPP_LKP_ERR_WRITING_MEMBLK_TO_CACHE_LKP_TEMP_FILE     LKPBASE +  107
#define ODPP_LKP_ERR_INCOMPATIBLE_OPTS_WITH_MTD_RANDOM         LKPBASE +  108
#define ODPP_LKP_ERR_READING_MEMBLK_FROM_RND_LKP_TEMP_FILE     LKPBASE +  109
#define ODPP_LKP_ERR_CACHE_TEMP_KEY_VAL_MALLOC_FAILED          LKPBASE +  110
#define ODPP_LKP_ERR_CACHE_KEY_VAL_MALLOC_FAILED               LKPBASE +  111
#define ODPP_LKP_ERR_CACHE_KEY_MALLOC_FAILED                   LKPBASE +  112
#define ODPP_LKP_ERR_READING_MEMBLK_FROM_CACHE_LKP_TEMP_FILE   LKPBASE +  114
#define ODPP_LKP_ERR_CACHE_KEY_LIST_MALLOC_FAILED              LKPBASE +  115
#define ODPP_LKP_ERR_PARSING_PRESERVE_NULL_COLS                LKPBASE +  116
#define ODPP_LKP_ERR_PARSING_PRESERVE_BLANK_COLS               LKPBASE +  117
#define ODPP_LKP_ERR_PARSING_PRESERVE_ZEROLEN_COLS             LKPBASE +  118
#define ODPP_LKP_ERR_RND_LKP_TEMP_FILE_SEEK_START              LKPBASE +  119
#define ODPP_LKP_ERR_READING_BLKID_FROM_RND_LKP_TEMP_FILE      LKPBASE +  120
#define ODPP_LKP_ERR_WRITING_BLKID_TO_CACHE_LKP_TEMP_FILE      LKPBASE +  121
#define ODPP_LKP_ERR_CACHE_LKP_TEMP_FILE_SEEK_START            LKPBASE +  122
#define ODPP_LKP_ERR_READING_BLKID_FROM_CACHE_LKP_TEMP_FILE    LKPBASE +  123
#define ODPP_LKP_ERR_GET_TEMP_PATH_FAILED                      LKPBASE +  124
#define ODPP_LKP_ERR_CNV_SVC_TKN_FAILED                        LKPBASE +  125
#define ODPP_LKP_ERR_REPCOLS_NAME_TEMP_BUF_MALLOC_FAILED       LKPBASE +  126
#define ODPP_LKP_ERR_REPCOL_NAME_BUF_MALLOC_FAILED             LKPBASE +  127 // 6015
#define ODPP_LKP_ERR_PRSRVNULL_COLS_NAME_TEMP_BUF_MALLOC_FAILED      LKPBASE +  128
#define ODPP_LKP_ERR_PRSRVBLANK_COLS_NAME_TEMP_BUF_MALLOC_FAILED     LKPBASE +  129
#define ODPP_LKP_ERR_PRSRVZEROLEN_COLS_NAME_TEMP_BUF_MALLOC_FAILED   LKPBASE +  130
#define ODPP_LKP_ERR_SEQCOL_NAME_BUF_MALLOC_FAILED             LKPBASE +  131
#define ODPP_LKP_ERR_CNTCOL_COL_NAME_BUF_MALLOC_FAILED         LKPBASE +  132
#define ODPP_LKP_ERR_USER_REP_DATA_EMPTY                       LKPBASE +  133
#define ODPP_LKP_ERR_USER_REP_DATA_SRCBUF_EMPTY                LKPBASE +  134
#define ODPP_LKP_ERR_USER_REP_DATA_BUF_MALLOC_FAILED           LKPBASE +  135  // 6023
#define ODPP_LKP_ERR_CTRLBLK_X_MALLOC_FAILED                   LKPBASE +  136
#define ODPP_LKP_ERR_PARAM_X_MALLOC_FAILED                     LKPBASE +  137
#define ODPP_LKP_ERR_SRCH_LDSFLD_X_MALLOC_FAILED               LKPBASE +  138
#define ODPP_LKP_ERR_REPL_LDSFLD_X_MALLOC_FAILED               LKPBASE +  139
#define ODPP_LKP_ERR_FIELD_X_MALLOC_FAILED                     LKPBASE +  140
#define ODPP_LKP_ERR_PARAMS_X_MALLOC_FAILED                    LKPBASE +  141
#define ODPP_LKP_WARN_NO_LOOKUP_DATA                           LKPBASE +  142 //6030
#define ODPP_LKP_ERR_MULTIPLE_SEED_OPERANDS                    LKPBASE +  143 //6031
#define ODPP_LKP_ERR_HASHLIBAPI_MALLOC_FAILED                  LKPBASE +  144 //6032
#define ODPP_LKP_ERR_SEED_HMAC_ALGO_NATIVE                     LKPBASE +  145 //6033

/* Warning Error Codes */
#define ODPP_LKP_WARN_GET_SRC_BYTES_FAILED               LKPBASE +  50 // 5938

/* Informational Error Codes */
#define ODPP_LKP_INFO_SRVMETHOD                          LKPBASE +  70 // 5958
#define ODPP_LKP_INFO_DATATYPE_LEN_NA                    LKPBASE +  71 // 5959
#define ODPP_LKP_INFO_SPECIAL_VALUE                      LKPBASE +  72 // 5960
#define ODPP_LKP_INFO_CACHE_KEY_NOT_FOUND                LKPBASE +  73 // 5961


/*=======================================================
   LDS DB2 error codes
  ======================================================*/
/* Range 0x00001800 to 0x000018FF   -> i.e. 256 error codes */
#define LDSDB2BASE                                       0x00001800
#define ODPP_LDS_DB2_ERR_NULL_LDSTOKEN                   LDSDB2BASE + 0  //6144
#define ODPP_LDS_DB2_ERR_MALLOCFAILED_CONNNODE           LDSDB2BASE + 4  //6148
#define ODPP_LDS_DB2_ERR_CONNECT_FAILED                  LDSDB2BASE + 5  //6149
#define ODPP_LDS_DB2_ERR_ALLOC_HANDLE_ENV_FAILED         LDSDB2BASE + 9  //6153
#define ODPP_LDS_DB2_ERR_ALLOC_HANDLE_DBC_FAILED         LDSDB2BASE + 10 //6154
#define ODPP_LDS_DB2_ERR_ALLOC_HANDLE_STMT_FAILED        LDSDB2BASE + 11 //6155
#define ODPP_LDS_DB2_ERR_SET_ATTR_ENV_FAILED             LDSDB2BASE + 12 //6156
#define ODPP_LDS_DB2_WARN_NODE_LIST_NOT_EMPTY            LDSDB2BASE + 13 //6157
#define ODPP_LDS_DB2_ERR_NULL_BASENODE                   LDSDB2BASE + 14 //6158
#define ODPP_LDS_DB2_ERR_LDSTOKEN_NOTFOUND               LDSDB2BASE + 15 //6159
#define ODPP_LDS_DB2_ERR_NULL_LDSFLDDEF                  LDSDB2BASE + 16 //6160
#define ODPP_LDS_DB2_ERR_FETCH_COLUMN_FAILED             LDSDB2BASE + 17 //6161
#define ODPP_LDS_DB2_ERR_NO_LDS_COLUMNS                  LDSDB2BASE + 18 //6162
#define ODPP_LDS_DB2_INFO_NO_LOOKUP_DATA                 LDSDB2BASE + 22
#define ODPP_LDS_DB2_ERR_MALLOCFAILED_STMT_STRING        LDSDB2BASE + 23
#define ODPP_LDS_DB2_ERR_PREPARE_FAILED                  LDSDB2BASE + 24
#define ODPP_LDS_DB2_ERR_BINDPARAM_FAILED                LDSDB2BASE + 25
#define ODPP_LDS_DB2_ERR_UNSUPPORTED_DATATYPE            LDSDB2BASE + 26
#define ODPP_LDS_DB2_ERR_EXEC_STMT_FAILED                LDSDB2BASE + 27
#define ODPP_LDS_DB2_ERR_NULL_LOOKUP_BUF                 LDSDB2BASE + 28
#define ODPP_LDS_DB2_ERR_FREE_STMT_FAILED                LDSDB2BASE + 29
#define ODPP_LDS_DB2_ERR_READING_COL_DATA                LDSDB2BASE + 30
#define ODPP_LDS_DB2_ERR_SQLTYPES_ALLOC_FAILED           LDSDB2BASE + 31
#define ODPP_LDS_DB2_ERR_GET_SQLTYPE_FAILED              LDSDB2BASE + 32
#define ODPP_LDS_DB2_ERR_MALLOCFAILED_DBCSSTMT_STRING    LDSDB2BASE + 33
#define ODPP_LDS_DB2_ERR_MALLOCFAILED_DBCS_DATA_BUFFER   LDSDB2BASE + 34
#define ODPP_LDS_DB2_ERR_FETCH_TBL_FAILED                LDSDB2BASE + 35 //6179
#define ODPP_LDS_DB2_ERR_DATATYPE_ZERO                   LDSDB2BASE + 36 //6180
#define ODPP_LDS_DB2_ERR_HASHFLD_DECIMAL_TYPE            LDSDB2BASE + 37 //6181
#define ODPP_LKP_ERR_SOURCE_DATA_LARGER_THAN_SEARCH_COL  LDSDB2BASE + 38 //6182


/*=======================================================
   HASH Provider error codes
  ======================================================*/
/* Range 0x00001900 to 0x000019FF   -> i.e. 256 error codes */
#define HASHBASE                                         0x00001900
#define ODPP_HASH_ERR_HASHCTRLBLK_MALLOC_FAILED          HASHBASE + 0  // 6400
#define ODPP_HASH_ERR_TRIM_CHARS_MALLOC_FAILED           HASHBASE + 2  // 6402
#define ODPP_HASH_ERR_HASHCOL_MALLOC_FAILED              HASHBASE + 5  // 6405
#define ODPP_HASH_ERR_NULL_HASHCOL                       HASHBASE + 6  // 6406
#define ODPP_HASH_ERR_COL_DATATYPE_NOTSUPPORTED          HASHBASE + 7
#define ODPP_HASH_ERR_INVALID_DEST_COLUMN                HASHBASE + 8
#define ODPP_HASH_ERR_DEST_COL_MALLOC_FAILED             HASHBASE + 9
#define ODPP_HASH_ERR_INVALID_SEED_COLUMN                HASHBASE + 10 // 6410
#define ODPP_HASH_ERR_SEED_COL_MALLOC_FAILED             HASHBASE + 11
#define ODPP_HASH_ERR_MULTIPLE_SEED_OPERANDS             HASHBASE + 12
#define ODPP_HASH_ERR_DST_COL_DATATYPE_NOTSUPPORTED      HASHBASE + 13
#define ODPP_HASH_ERR_NULL_DEST_COL                      HASHBASE + 16
#define ODPP_HASH_ERR_NULL_SEED_COL                      HASHBASE + 17
#define ODPP_HASH_ERR_NULL_SEED_ENVVAR                   HASHBASE + 18
#define ODPP_HASH_ERR_NO_HASHCTRLBLK                     HASHBASE + 19
#define ODPP_HASH_ERR_ENVVAR_CONVERT_FAILED              HASHBASE + 20 // 6420
#define ODPP_HASH_ERR_GET_ENVVAL_FAILED                  HASHBASE + 21
#define ODPP_HASH_ERR_ENVVAL_CONVERT_FAILED              HASHBASE + 22
#define ODPP_HASH_ERR_UNKNOWN_REQUEST                    HASHBASE + 23
#define ODPP_HASH_ERR_HASHCOL_BUF_MALLOC_FAILED          HASHBASE + 24
#define ODPP_HASH_ERR_ROWSET_EMPTY                       HASHBASE + 26
#define ODPP_HASH_ERR_NOT_ENOUGH_DATA_BLOCKS             HASHBASE + 27
#define ODPP_HASH_ERR_INVALID_METHOD                     HASHBASE + 28
#define ODPP_HASH_ERR_NO_SOURCE_DATA_COL                 HASHBASE + 29
#define ODPP_HASH_ERR_CONVERSION_SRC                     HASHBASE + 30 // 6430
#define ODPP_HASH_ERR_CONVERSION_SEED                    HASHBASE + 31
#define ODPP_HASH_ERR_NO_SEED_DATA_COL                   HASHBASE + 32
#define ODPP_HASH_ERR_NO_DEST_DATA_COL                   HASHBASE + 33
#define ODPP_HASH_ERR_HASHSTRING_MALLOC_FAILED           HASHBASE + 34
#define ODPP_HASH_ERR_HASHSRC_CONCATENATE_FAILED         HASHBASE + 35
#define ODPP_HASH_ERR_TRIM_CHARS_FAILED                  HASHBASE + 36
#define ODPP_HASH_ERR_NO_SOURCE_DATA_TO_HASH             HASHBASE + 37
#define ODPP_HASH_ERR_BLANK_SOURCE_DATA_TO_HASH          HASHBASE + 38
#define ODPP_HASH_ERR_NULL_SRC_BUFFER                    HASHBASE + 39
#define ODPP_HASH_ERR_NULL_DEST_BUFFER                   HASHBASE + 40 // 6440
#define ODPP_HASH_ERR_1ST_CONVERSION_DEST                HASHBASE + 41
#define ODPP_HASH_ERR_2ND_CONVERSION_DEST                HASHBASE + 42
#define ODPP_HASH_ERR_DEST_TYPE_NOSUPPORT_WO_HASHMAXVAL  HASHBASE + 43
#define ODPP_HASH_INFO_ENDOF_FORMAT_STACK                HASHBASE + 44
#define ODPP_HASH_ERR_FMTCODES_MALLOC_FAILED             HASHBASE + 45
#define ODPP_HASH_WARN_NULL_SOURCE_DATA                  HASHBASE + 47
#define ODPP_HASH_WARN_NO_SOURCE_DATA_AFTER_TRIM         HASHBASE + 48
#define ODPP_HASH_WARN_BLANK_SOURCE_DATA                 HASHBASE + 49
#define ODPP_HASH_ERR_MULTIPLE_ALGO_PARAMS               HASHBASE + 50 //6450
#define ODPP_HASH_ERR_INVALID_SEED_FOR_ALGO_SHA256       HASHBASE + 51 //6451
#define ODPP_HASH_ERR_HASHLIBAPI_MALLOC_FAILED           HASHBASE + 52 //6452
#define ODPP_HASH_ERR_SEED_HMAC_ALGO_NATIVE              HASHBASE + 53 //6453
// 2014/02/20, takahak, WI 48336
#define ODPP_HASH_ERR_HASHMAX_EXCEED_DSTFLD              HASHBASE + 54 // d48336A
#define ODPP_HASH_ERR_HEAP_CREATE_FAILED                 HASHBASE + 55 //6455
#define ODPP_HASH_ERR_HEAP_DISCARD_FAILED                HASHBASE + 56 //6456 

/*=======================================================
   AGE Provider error codes
  ======================================================*/
/* Range 0x00001A00 to 0x00001AFF   -> i.e. 256 error codes */
#define AGEBASE                                          0x00001A00
#define ODPP_AGE_ERR_AGECTRLBLK_MALLOC_FAILED            AGEBASE + 0 //6656
#define ODPP_AGE_ERR_SRC_FMTCODES_MALLOC_FAILED          AGEBASE + 1
#define ODPP_AGE_ERR_DST_FMTCODES_MALLOC_FAILED          AGEBASE + 2
#define ODPP_AGE_ERR_AGING_INCR_YEARS_OUTOFRANGE         AGEBASE + 3
#define ODPP_AGE_ERR_AGING_INCR_MONTHS_OUTOFRANGE        AGEBASE + 4
#define ODPP_AGE_ERR_AGING_INCR_DAYS_OUTOFRANGE          AGEBASE + 5
#define ODPP_AGE_ERR_AGING_INCR_WEEKS_OUTOFRANGE         AGEBASE + 6
#define ODPP_AGE_ERR_AGING_YEAR_OUTOFRANGE               AGEBASE + 7
#define ODPP_AGE_ERR_AGING_CENT_PIVOT_OUTOFRANGE         AGEBASE + 8
#define ODPP_AGE_ERR_NO_AGECTRLBLK                       AGEBASE + 9
#define ODPP_AGE_ERR_ROWSET_EMPTY                        AGEBASE + 10
#define ODPP_AGE_ERR_SRCOLIDX_EXCEEDS_ROWDEF_COLCOUNT    AGEBASE + 11
#define ODPP_AGE_INFO_SRVMETHOD                          AGEBASE + 12
#define ODPP_AGE_ERR_INVALID_METHOD                      AGEBASE + 13
#define ODPP_AGE_ERR_SOURCE_DATA_COL_NOT_FOUND           AGEBASE + 14
#define ODPP_AGE_ERR_CONVERSION_SRC_TO_TIMESTAMP         AGEBASE + 15
#define ODPP_AGE_INFO_NULL_SOURCE_DATA                    AGEBASE + 16
#define ODPP_AGE_ERR_NULL_DEST_BUFFER                    AGEBASE + 17
#define ODPP_AGE_ERR_CONVERTING_DSTDATA_TO_DEST_DATATYPE AGEBASE + 18
#define ODPP_AGE_ERR_NULL_AGECOL                         AGEBASE + 19
#define ODPP_AGE_ERR_SRCCOL_DATATYPE_NOTSUPPORTED        AGEBASE + 20
#define ODPP_AGE_ERR_DSTCOL_DATATYPE_NOTSUPPORTED        AGEBASE + 21
#define ODPP_AGE_ERR_NO_AGING_OPTION_SUPPLIED            AGEBASE + 22
#define ODPP_AGE_ERR_NO_SRC_FORMAT_SUPPLIED              AGEBASE + 23
#define ODPP_AGE_ERR_OUT_FLD_CNV_BLK_MALLOC_FAILED       AGEBASE + 24
#define ODPP_AGE_ERR_HEAP_CREATE_FAILED                  AGEBASE + 25
#define ODPP_AGE_ERR_HEAP_DISCARD_FAILED                 AGEBASE + 26
// 2014/05/20, takahak, WI 58856
#define ODPP_AGE_INFO_SPACES_SOURCE_DATA                 AGEBASE + 27 // 6683

/*=======================================================
   TRACE ERROR CODES
  ======================================================*/
/* Range 0x00001B00 to 0x00001B1F   -> i.e. 32 error codes */
#define TRACEBASE                                           0x00001B00
#define ODPP_TRC_ERR_TCB_MALLOC_FAILED                      TRACEBASE + 0 //6912
#define ODPP_TRC_ERR_GET_TEMP_PATH_FAILED                   TRACEBASE + 1 //6913
#define ODPP_TRC_ERR_TRACE_PATH_CONVERT_FAILED              TRACEBASE + 2 //6914
#define ODPP_TRC_ERR_TRACE_FILE_CREATE_FAILED               TRACEBASE + 3 //6915
/*Vinit WI 25686 : Writing Trace entries in ODPP code BEGIN*/
#define ODPP_TRC_ERR_TRACE_FILE_STAT_FAILED                 TRACEBASE + 4 //6916
/*Vinit WI 25686 : Writing Trace entries in ODPP code END*/
#define ODPP_TRC_ERR_TRACE_PATH_MALLOC_FAILED               TRACEBASE + 5 //6917
#define ODPP_TRC_ERR_INVALID_TRACE_PATH_BUFFER_SIZE         TRACEBASE + 6 //6918
#define ODPP_TRC_ERR_INVALID_TRACE_NAME_BUFFER_SIZE         TRACEBASE + 7 //6919
#define ODPP_TRC_ERR_TRACE_NAME_CONVERT_FAILED              TRACEBASE + 8 //6920
/*=======================================================
   License Lib ERROR CODES
  ======================================================*/
/* Range 0x00001B20 to 0x00001B51   -> i.e. 50 error codes */
#define LICBASE                                             0x00001B20 //6944
#define ODPP_LIC_ERR_INVALID_LIC_PATH_BUFFER_SIZE           LICBASE + 34

/*=======================================================
   License Program ERROR CODES
  ======================================================*/
/* Range 0x00001B52 to 0x00001B65   -> i.e. 20 error codes */
#define LICPRGBASE                                          0x00001B52
#define ODPP_LIC_ERR_NULL_LICENSE_PATH_BUFFER               LICPRGBASE + 3

// Range 0x00001B66 to 0x00001B7E i.e. 25 error codes
#define ICUBASE                                             0x00001B66
#define ODPP_ICU_ERR_DIR_SRCH_CLOSEHANDLE_FAILED            ICUBASE + 0
#define ODPP_ICU_WARN_NO_ALIAS_FILE_FOUND                   ICUBASE + 1

// Range 0x00001B7F to 0x00001BB0 i.e. 50 error codes
#define ADAPTERBASE                                            0x00001B7F     //7039
#define ODPP_PRMGEN_ERR_FLD_DEF_MALLOC_FAILED                  ADAPTERBASE + 0
#define ODPP_PRMGEN_ERR_FLD_DEF_WC_SS_MALLOC_FAILED            ADAPTERBASE + 1
#define ODPP_PRMGEN_ERR_PARAM_VAL_WC_SS_MALLOC_FAILED          ADAPTERBASE + 2
#define ODPP_PRMGEN_ERR_PARAM_VAL_W_BUF_MALLOC_FAILED          ADAPTERBASE + 3
#define ODPP_PRMGEN_ERR_PARAM_BLK_MALLOC_FAILED                ADAPTERBASE + 4
#define ODPP_PRMGEN_ERR_COLNAME_W_BUF_MALLOC_FAILED            ADAPTERBASE + 5
#define ODPP_PRMGEN_ERR_INVALID_PART_NO_END_PARENTH            ADAPTERBASE + 6
#define ODPP_PRMGEN_ERR_INVALID_PARTS_NO_START_PARENTH         ADAPTERBASE + 7
#define ODPP_PRMGEN_ERR_INVALID_FIELDDEF_INDEX                 ADAPTERBASE + 8
#define ODPP_PRMGEN_ERR_EAB_MALLOC_FAILED                      ADAPTERBASE + 9
#define ODPP_PRMGEN_ERR_NO_HASH_FLDS                           ADAPTERBASE + 10
#define ODPP_PRMGEN_ERR_WIDE_TO_INT_CNV_FAILED                 ADAPTERBASE + 11
#define ODPP_PRMGEN_ERR_NID_FORMAT_DECODE_FAILED               ADAPTERBASE + 12

#define ODPP_PRMGEN_ERR_FLD_DEF_MC_SS_MALLOC_FAILED            ADAPTERBASE + 13
#define ODPP_PRMGEN_ERR_COLNAME_M_BUF_MALLOC_FAILED            ADAPTERBASE + 14
#define ODPP_PRMGEN_ERR_COLNAME_CNV_W_TO_M_FAILED              ADAPTERBASE + 15
#define ODPP_PRMGEN_ERR_SVCID_CNV_W_TO_M_FAILED                ADAPTERBASE + 16 //7055
#define ODPP_PRMGEN_ERR_PARAM_VAL_MC_SS_MALLOC_FAILED          ADAPTERBASE + 17 //7056
#define ODPP_PRMGEN_ERR_PARAM_VAL_M_BUF_MALLOC_FAILED          ADAPTERBASE + 18 //7057
#define ODPP_PRMGEN_ERR_PARAM_INVALID_LOOKUP_LIB               ADAPTERBASE + 19 //7058

// Range 0x00001BB1 to 0x00001C14 i.e. 100 error codes
#define PARSERBASE                                                      0x00001BB1     //7089
#define ODPP_PARSER_CMN_ERR_PARAMSTR_MALLOC_FAILED                      PARSERBASE + 0
#define ODPP_PARSER_CMN_ERR_PARAMSTR_NO_LENGTH                          PARSERBASE + 1
#define ODPP_PARSER_CMN_ERR_PARAMSTR_NULL                               PARSERBASE + 2
#define ODPP_PARSER_CMN_ERR_PARAMSTR_TYPE_INVALID                       PARSERBASE + 3
#define ODPP_PARSER_CMN_ERR_KEYVALARR_OVERFLOW                          PARSERBASE + 4
//#define ODPP_PARSER_CMN_ERR_INITDATACNV_FAILED                          PARSERBASE + 5
#define ODPP_PARSER_CMN_ERR_DATACNV_FAILED                              PARSERBASE + 6
#define ODPP_PARSER_CMN_ERR_INCOMPATIBLE_PARAMS_MTDRND_PRE              PARSERBASE + 7
#define ODPP_PARSER_CMN_ERR_INCOMPATIBLE_PARAMS_MTDRND_VAL              PARSERBASE + 8
//#define ODPP_PARSER_CMN_ERR_SYNTAX_INVALID                              PARSERBASE + 9
#define ODPP_PARSER_CMN_ERR_PARAM_PROVIDER_INVALID                      PARSERBASE + 10
#define ODPP_PARSER_CMN_ERR_KEY_AND_VALUE_TRUNCATED                     PARSERBASE + 11
#define ODPP_PARSER_CMN_ERR_KEY_TRUNCATED                               PARSERBASE + 12
#define ODPP_PARSER_CMN_ERR_VALUE_TRUNCATED                             PARSERBASE + 13
#define ODPP_PARSER_CMN_ERR_DATA_TRUNCATED                              PARSERBASE + 14
#define ODPP_PARSER_NID_ERR_NO_MAND_PARAM_SWITCH                        PARSERBASE + 15
#define ODPP_PARSER_NID_ERR_INCOMPATIBLE_PARAMS_AREATABLE_CTRY          PARSERBASE + 16
#define ODPP_PARSER_CCN_ERR_INCOMPATIBLE_PARAMS_MTDRND_PATTERN          PARSERBASE + 17
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_USERPREFIX_NAMECOLS     PARSERBASE + 18
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_USERPREFIX      PARSERBASE + 19
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_NAMECOLS        PARSERBASE + 20
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_CASE            PARSERBASE + 21
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_FCNAME1         PARSERBASE + 22
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_LITDOMAIN       PARSERBASE + 23
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_EMLHASH_SEPARATOR       PARSERBASE + 24
#define ODPP_PARSER_EML_ERR_LITDOMAIN_LEN_INVALID                       PARSERBASE + 25
#define ODPP_PARSER_EML_ERR_USERPREFIX_LEN_INVALID                      PARSERBASE + 26
#define ODPP_PARSER_EML_ERR_HASHSEED_LEN_INVALID                        PARSERBASE + 27
#define ODPP_PARSER_COL_ERR_NO_MAND_PARAM_METHOD                        PARSERBASE + 28
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLLEN_UNIQUE           PARSERBASE + 29
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLLEN_COLBIN           PARSERBASE + 30
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLLEN_COLNUM           PARSERBASE + 31
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLBIN_COPY             PARSERBASE + 32
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLBIN_REMOVE           PARSERBASE + 33
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLBIN_CASE             PARSERBASE + 34
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLBIN_TRIM             PARSERBASE + 35
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_COLNUM_COPY             PARSERBASE + 36
#define ODPP_PARSER_AGE_ERR_YEAR_INVALID                                PARSERBASE + 37
#define ODPP_PARSER_AGE_ERR_MONTH_INVALID                               PARSERBASE + 38
#define ODPP_PARSER_AGE_ERR_WEEK_INVALID                                PARSERBASE + 39
#define ODPP_PARSER_AGE_ERR_DAY_INVALID                                 PARSERBASE + 40
#define ODPP_PARSER_AGE_ERR_SPECIFICYEAR_INVALID                        PARSERBASE + 41
#define ODPP_PARSER_AGE_ERR_PIVOT_INVALID                               PARSERBASE + 42
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_SPECYEAR_YEAR           PARSERBASE + 43
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_SPECYEAR_MONTH          PARSERBASE + 44
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_SPECYEAR_WEEK           PARSERBASE + 45
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_SPECYEAR_DAY            PARSERBASE + 46
#define ODPP_PARSER_CMN_ERR_SEED_VALUE_INVALID                          PARSERBASE + 47
#define ODPP_PARSER_LKP_ERR_LIMIT_VALUE_INVALID                         PARSERBASE + 48
#define ODPP_PARSER_LKP_ERR_NO_MAND_PARAM_REPLACE                       PARSERBASE + 49
#define ODPP_PARSER_CMN_ERR_ANTLR_EXCEPTION                             PARSERBASE + 50
#define ODPP_PARSER_CMN_ERR_INVALID_SEP                                 PARSERBASE + 51
#define ODPP_PARSER_LKP_ERR_REQD_PARM_CACHE_NOTFOUND                    PARSERBASE + 52
#define ODPP_PARSER_LKP_ERR_CACHESIZE_INVALID                           PARSERBASE + 53
#define ODPP_PARSER_CMN_ERR_EAB_MALLOC_FAILED                           PARSERBASE + 54
#define ODPP_PARSER_CMN_ERR_NO_MAND_PARAM_DSTFLD                        PARSERBASE + 55
#define ODPP_PARSER_CMN_ERR_NO_MAND_PARAM_FLDDEF                        PARSERBASE + 56
#define ODPP_PARSER_CMN_ERR_NO_MAND_PARAM_FLDDEF_NAME                   PARSERBASE + 57
#define ODPP_PARSER_CMN_ERR_NO_MAND_PARAM_FLDDEF_DATATYPE               PARSERBASE + 58
#define ODPP_PARSER_ERROR                                               PARSERBASE + 59 //7148
#define ODPP_PARSER_LKP_ERR_NO_MAND_PARAM_SEARCH                        PARSERBASE + 60 //7149
#define ODPP_PARSER_LKP_ERR_NO_MAND_PARAM_SOURCE                        PARSERBASE + 61 //7150
#define ODPP_PARSER_DSWAP_ERR_NO_MAND_PARAM_SWAP_FIELD                  PARSERBASE + 62 //7151
#define ODPP_PARSER_DSWAP_ERR_NO_MAND_PARAM_CONTROL_FIELD               PARSERBASE + 63 //7152
#define ODPP_PARSER_DSWAP_ERR_NO_MAND_PARAM_BLOCK_SIZE                  PARSERBASE + 64 //7153
#define ODPP_PARSER_EML_ERR_NO_REQD_PARAM_MTDHASH_FOR_HASHDOM_SEED_AND_ALGO  PARSERBASE + 65 //7154
#define ODPP_PARSER_CMN_ERR_SEED_HMAC_ALGO_DEFAULT                      PARSERBASE + 66 //7155
#define ODPP_PARSER_HASH_ERR_INVALID_SEED_FOR_ALGO_SHA256               PARSERBASE + 67 //7156
#define ODPP_PARSER_EML_ERR_INVALID_SEEDVAL_FOR_ALGO_SHA256             PARSERBASE + 68 //7157
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_MTD_RND_HASHDOMAIN      PARSERBASE + 69 //7158
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_MTD_RND_LITDOMAIN       PARSERBASE + 70 //7159
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_MTD_RND_HASHSEED        PARSERBASE + 71 //7160
#define ODPP_PARSER_EML_ERR_INCOMPATIBLE_PARAMS_MTD_RND_HASHALGO        PARSERBASE + 72 //7161
#define ODPP_PARSER_LKP_ERR_CASE_VALUE_INVALID                          PARSERBASE + 73 //7162
#define ODPP_PARSER_HASH_ERR_CASE_VALUE_INVALID                         PARSERBASE + 74 //7163
#define ODPP_PARSER_HASH_ERR_HASHMAX_OUT_OF_RANGE                       PARSERBASE + 75 //7164
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_KEY_ALGO_DEFAULT        PARSERBASE + 76 //7165
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_ITERATIONS_ALGO_DEFAULT PARSERBASE + 77 //7166
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_TWEAKS_ALGO_DEFAULT     PARSERBASE + 78 //7167
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_SEED_ALGO_FPE           PARSERBASE + 79 //7168

#define ODPP_PARSER_COL_ERR_ALGO_FPE_REQD_PARM_KEY_NOTFOUND             PARSERBASE + 80 //7169
#define ODPP_PARSER_COL_ERR_ITERATIONS_OUT_OF_RANGE                     PARSERBASE + 81 //7170
#define ODPP_PARSER_COL_ERR_KEY_LENGTH_INVALID                          PARSERBASE + 82 //7171
#define ODPP_PARSER_COL_ERR_INCOMPATIBLE_PARAMS_ALGO_FPE_MTD_HASH       PARSERBASE + 83 //7172
#define ODPP_PARSER_NID_ERR_INVALID_FORMAT                              PARSERBASE + 84 //7173
#define ODPP_PARSER_CMN_ERR_TRCLVLSTR_MALLOC_FAILED                     PARSERBASE + 85 //7174
#define ODPP_PARSER_CMN_ERR_TRCLVLSTR_CNV_TO_UTF8_FAILED                PARSERBASE + 86 //7175
#define ODPP_PARSER_LKPFLD_MISSING_QUOTE                                PARSERBASE + 87 //7176
#define ODPP_PARSER_SWAP_MISSING_QUOTE                                  PARSERBASE + 88 //7177
#define ODPP_PARSER_EML_MISSING_QUOTE                                   PARSERBASE + 89 //7178
#define ODPP_PARSER_REMOVE_OR_SEP_MISSING_QUOTE                         PARSERBASE + 90 //7179
#define ODPP_PARSER_LKPPRE_MISSING_QUOTE                                PARSERBASE + 91 //7180
#define ODPP_PARSER_COPY_MISSING_QUOTE                                  PARSERBASE + 92 //7181
#define ODPP_PARSER_LANG_MISSING_QUOTE                                  PARSERBASE + 93 //7182
#define ODPP_PARSER_AGE_ANY_NOT_ALLOWED                                 PARSERBASE + 94 //7183
#define ODPP_PARSER_AGE_INCOMPATIBLE_PARAMS_NEGATIVE                    PARSERBASE + 95 //7184
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_FORMAT_VS_DATATYPE      PARSERBASE + 96 //7185
#define ODPP_PARSER_AGE_ERR_INCOMPATIBLE_PARAMS_SPECYEAR_RANDOM         PARSERBASE + 97 //7186

// Range 0x00001C15 to 0x00001C1E i.e. 10 error codes
//Error Handler
#define ERRHNDBASE                                                      0x00001C15 //7189
#define ODPP_ERRHND_CMN_ERR_ERRCODE_NOTFOUND                            ERRHNDBASE + 0

// Range 0x00001C1F to 0x00001C32 i.e. 20 error codes
//Instance Manager
#define INSTMGRBASE                                                     0x00001C1F //7199
#define ODPP_INSTMGR_ERR_INSTANCEDEF_NOTFOUND                           INSTMGRBASE + 0//7199
#define ODPP_INSTMGR_ERR_INSTANCE_LST_ENTRY_MALLOC_FAILED               INSTMGRBASE + 1//7200
#define ODPP_INSTMGR_ERR_PARMSTR_MALLOC_FAILED                          INSTMGRBASE + 2//7201
#define ODPP_INSTMGR_ERR_MUTEX_NOT_LOCKED                               INSTMGRBASE + 3//7202
#define ODPP_INSTMGR_ERR_GLOBAL_LOCK_FAILED                             INSTMGRBASE + 4//7203

// Range 0x00001C33(7219) to 0x00001C64(7268) i.e. 50 error codes
//Netezza UDF
#define UDFCMNBASE                                                      0x00001C33 //7219
#define ODPP_UDF_ERR_PRSR_PARAM_MC_MALLOC_FAILED                        UDFCMNBASE + 0 //7219
#define ODPP_UDF_ERR_PRSR_KEYVAL_ARR_MALLOC_FAILED                      UDFCMNBASE + 1 //7220
#define ODPP_UDF_ERR_PRSR_KEY_MALLOC_FAILED                             UDFCMNBASE + 2 //7221
#define ODPP_UDF_ERR_PRSR_VAL_MALLOC_FAILED                             UDFCMNBASE + 3 //7222
#define ODPP_UDF_ERR_INVALID_ODPP_DATATYPE                              UDFCMNBASE + 4 //7223
#define ODPP_UDF_ERR_NO_PARM_STRING                                     UDFCMNBASE + 5 //7224
#define ODPP_UDF_ERR_DATA_FIELD_MALLOC_FAILED                           UDFCMNBASE + 6 //7225
#define ODPP_UDF_ERR_SRC_BUF_MALLOC_FAILED                              UDFCMNBASE + 7 //7226
#define ODPP_UDF_INFO_DST_NULL                                          UDFCMNBASE + 8 //7227
#define ODPP_UDF_ERR_DST_BUF_MALLOC_FAILED                              UDFCMNBASE + 9 //7228
#define ODPP_UDF_ERR_BLK_MALLOC_FAILED                                  UDFCMNBASE + 10 //7229
#define ODPP_UDF_ERR_NO_FLD_LENGTH                                      UDFCMNBASE + 11 //7230
#define ODPP_UDF_ERR_INVALID_SRC_COL_IDX_BUF_LEN                        UDFCMNBASE + 12 //7231
#define ODPP_UDF_ERR_SRC_COLIDX_BUF_MALLOC_FAILED                       UDFCMNBASE + 13 //7232
#define ODPP_UDF_ERR_SVC_DEF_MALLOC_FAILED                              UDFCMNBASE + 14 //7233
#define ODPP_UDF_ERR_ROWSET_MALLOC_FAILED                               UDFCMNBASE + 15 //7234
#define ODPP_UDF_ERR_ROWDEF_MALLOC_FAILED                               UDFCMNBASE + 16 //7235
#define ODPP_UDF_ERR_USERDATA_MALLOC_FAILED                             UDFCMNBASE + 17 //7236
#define ODPP_UDF_ERR_ERRMSG_MALLOC_FAILED                               UDFCMNBASE + 18 //7237
#define ODPP_UDF_ERR_INVALID_ODPP_DST_DATATYPE                          UDFCMNBASE + 19 //7238
#define ODPP_UDF_ERR_SUPPLIED_ARGS_EXCEEDS_FLD_COUNT                    UDFCMNBASE + 20 //7239
#define ODPP_UDF_ERR_DST_BUF_NULL                                       UDFCMNBASE + 21 //7240

#define ODPP_UDF_ERR_UDF_DST_DATA_FIELD_MALLOC_FAILED                   UDFCMNBASE + 22 //7241
#define ODPP_UDF_ERR_UDF_SRC_DATA_FIELD_MALLOC_FAILED                   UDFCMNBASE + 23 //7242
#define ODPP_UDF_ERR_INSUFFICIENT_DST_BUFFER                            UDFCMNBASE + 24 //7243
#define ODPP_UDF_ERR_PARAM_STR_MALLOC_FAILED                            UDFCMNBASE + 25 //7244
#define ODPP_UDF_ERR_PARAM_STR_16TO8_CNV_FAILED                         UDFCMNBASE + 26 //7245
#define ODPP_UDF_ERR_UDFCFG_MALLOC_FAILED                               UDFCMNBASE + 27 //7246
#define ODPP_UDF_ERR_DST_CNV_16_BE_BUF_MALLOC_FAILED                    UDFCMNBASE + 28 //7247
#define ODPP_UDF_ERR_EAB_MALLOC_FAILED                                  UDFCMNBASE + 29 //7248
#define ODPP_UDF_ERR_PRSR_PARAM_WC_MALLOC_FAILED                        UDFCMNBASE + 30 //7249
#define ODPP_UDF_ERR_UNSUPPORTED_PROVIDER                               UDFCMNBASE + 31 //7250

// Range 0x00001C65(7269) to 0x00001C96(7318)i.e. 50 error codes
//UDF Oracle
#define UDFORABASE                                                      0x00001C65 //7269
#define ODPP_UDF_ERR_ORA_OCI_GETENV_FAILED                              UDFORABASE + 0 //7269
#define ODPP_UDF_ERR_ORA_GET_USER_DATA_FAILED                           UDFORABASE + 1 //7270
#define ODPP_UDF_ERR_ORA_OCI_NUMBER_CNV_FAILED                          UDFORABASE + 2 //7271
#define ODPP_UDF_ERR_ORA_OCI_DATE_CNV_FAILED                            UDFORABASE + 3 //7272
#define ODPP_UDF_ERR_ORA_OCI_TIME_CNV_FAILED                            UDFORABASE + 4 //7273
#define ODPP_UDF_ERR_ORA_OCI_SET_DATETIME_FAILED                        UDFORABASE + 5 //7274
#define ODPP_UDF_ERR_ORA_OCINUM_MALLOC_FAILED                           UDFORABASE + 6 //7275
#define ODPP_UDF_ERR_ORA_OCIDATE_MALLOC_FAILED                          UDFORABASE + 7 //7276
#define ODPP_UDF_ERR_ORA_DATATYPE_WCHAR_EXPECTED                        UDFORABASE + 8 //7277
#define ODPP_UDF_ERR_ORA_DATATYPE_CHAR_EXPECTED                         UDFORABASE + 9 //7278
#define ODPP_UDF_ERR_ORA_RETURN_STR_MALLOC_FAILED                       UDFORABASE + 10 //7279
#define ODPP_UDF_ERR_ORA_FUNC_NOT_MATCH_DATATYPE                        UDFORABASE + 11 //7280
#define ODPP_UDF_ERR_ORA_NULL_VALUE                                     UDFORABASE + 12 //7281
#define ODPP_UDF_ERR_ORA_DATATYPE_NOT_SUPPORTED                         UDFORABASE + 13 //7282


// Range 0x00001C97(7319) to 0x00001CC8(7368)i.e. 50 error codes
#define ODPPNZBASE                                                      0x00001C97//7319
#define ODPP_UDF_ERR_PRECISION_OUT_OF_RANGE                             ODPPNZBASE + 0 //7319
#define ODPP_UDF_ERR_SCALE_OUT_OF_RANGE                                 ODPPNZBASE + 1 //7320
#define ODPP_UDF_ERR_VALUE_OUT_OF_RANGE                                 ODPPNZBASE + 2 //7321
#define ODPP_UDF_ERR_INVALID_UDX_RET_DATATYPE                           ODPPNZBASE + 3 //7322
#define ODPP_UDF_ERR_INVALID_UDX_INPUT_DATATYPE                         ODPPNZBASE + 4 //7323
#define ODPP_UDF_ERR_FAILED_TO_GET_UDF_ENV                              ODPPNZBASE + 5 //7324
#define ODPP_UDF_ERR_NO_ENVIRONMENT_VARIABLE_SUPPLIED                   ODPPNZBASE + 6 //7325
#define ODPP_UDF_ERR_ENV_VAR_LENGTH_NOT_SPECIFIED                       ODPPNZBASE + 7 //7326
#define ODPP_UDF_ERR_ENV_PRECISION_NOT_SPECIFIED                        ODPPNZBASE + 8 //7327
#define ODPP_UDF_ERR_ENV_PRECISION_OUT_OF_RANGE                         ODPPNZBASE + 9 //7328
#define ODPP_UDF_ERR_ENV_SCALE_OUT_OF_RANGE                             ODPPNZBASE + 10 //7329
#define ODPP_UDF_ERR_INVALID_ENVIRONMENT_OPTION                         ODPPNZBASE + 11 //7330
#define ODPP_UDF_ERR_INVALID_INPUT_DATE                                 ODPPNZBASE + 12 //7331
#define ODPP_UDF_ERR_DECODING_DATE_VALUE                                ODPPNZBASE + 13 //7332
#define ODPP_UDF_ERR_INVALID_INPUT_TIME                                 ODPPNZBASE + 14 //7333
#define ODPP_UDF_ERR_DECODING_TIME_VALUE                                ODPPNZBASE + 15 //7334
#define ODPP_UDF_ERR_INVALID_INPUT_TIMESTAMP                            ODPPNZBASE + 16 //7335
#define ODPP_UDF_ERR_DECODING_TIMESTAMP_VALUE                           ODPPNZBASE + 17 //7336
#define ODPP_UDF_ERR_ENCODING_DATE_VALUE                                ODPPNZBASE + 18 //7337
#define ODPP_UDF_ERR_ENCODING_TIME_VALUE                                ODPPNZBASE + 19 //7338
#define ODPP_UDF_ERR_ENCODING_TIMESTAMP_VALUE                           ODPPNZBASE + 20 //7339

// Range 0x00001CC9(7369) to 0x00001DC2(7618)i.e. 250 error codes for Data Swapping providers
#define ODPPSWAPBASE                                     0x00001CC9        // 7369 
#define ODPP_SWAP_ERR_SWAPCTRLBLK_MALLOC_FAILED          ODPPSWAPBASE + 0  // 7369 
#define ODPP_SWAP_ERR_NO_SWAPCTRLBLK                     ODPPSWAPBASE + 1  // 7370 
#define ODPP_SWAP_ERR_ROWSET_EMPTY                       ODPPSWAPBASE + 2  // 7371 
#define ODPP_SWAP_ERR_INVALID_METHOD                     ODPPSWAPBASE + 3  // 7372 
#define ODPP_SWAP_ERR_NO_SWAP_FIELDS                     ODPPSWAPBASE + 4  // 7373  no swap fields specified
#define ODPP_SWAP_ERR_CNV_SWAP_FIELDS                    ODPPSWAPBASE + 5  // 7374   unable to convert swap field spec
#define ODPP_SWAP_ERR_HASH_TABLE_CREATION                ODPPSWAPBASE + 6  // 7375 
#define ODPP_SWAP_ERR_ROW_SUBSET_CREATION                ODPPSWAPBASE + 7  // 7376 
#define ODPP_SWAP_ERR_CODOMAIN_ALLOC                     ODPPSWAPBASE + 8  // 7377 
#define ODPP_SWAP_ERR_INVALID_BLOCK_SIZE                 ODPPSWAPBASE + 9  // 7378 
#define ODPP_SWAP_ERR_MALFORMED_DEST_BUF                 ODPPSWAPBASE + 10 // 7379 
#define ODPP_SWAP_ERR_NULL_SWAPCTRLBLK                   ODPPSWAPBASE + 11 // 7380 
#define ODPP_SWAP_ERR_INVALID_SEED_VALUE                 ODPPSWAPBASE + 12 // 7381 
#define ODPP_SWAP_ERR_INVALID_SWAPRATE                   ODPPSWAPBASE + 13 // 7382 
#define ODPP_SWAP_ERR_MISSING_CLASSIFIER_PARAMS          ODPPSWAPBASE + 14 // 7383 
#define ODPP_SWAP_ERR_INVALID_CTRL_ATTR                  ODPPSWAPBASE + 15 // 7384 
#define ODPP_SWAP_ERR_UNKNOWN_CLASSIFIER                 ODPPSWAPBASE + 16 // 7385 
#define ODPP_SWAP_ERR_CLASSIFIER_PARAM_SYNTAX_ERROR      ODPPSWAPBASE + 17 // 7386 
#define ODPP_SWAP_ERR_SWAP_INEFFECTIVE                   ODPPSWAPBASE + 18 // 7387 
#define ODPP_APR_ERR_POOL_ALLOCATION                     ODPPSWAPBASE + 19 // 7388  generic APR error code

// Range 0x00001DC3(7619) to 0x00001FC2(8130)i.e. 512 error codes for
// Masking on Demand engine and application layer errors

// Range 0x00001FC3(8131) to 0x00001FF4(8180)i.e. 50 error codes for
// ODPP Hash library errors

// Range 0x00001FF5(8181) to 0x00002058(8280) i.e. 100 error codes for
// Oracle LDS library
#define LDSORABASE                                       0x00001FF5  //(8181)
//Error codes used in Oracle Lookup class
#define ODPP_LDS_ERR_UNAME_MALLOC_FAILED              LDSORABASE + 0 //(8181)
#define ODPP_LDS_ERR_PASSWORD_MALLOC_FAILED           LDSORABASE + 1 //(8182)
#define ODPP_LDS_ERR_CONNSTR_MALLOC_FAILED            LDSORABASE + 2 //(8183)
#define ODPP_LDS_ERR_SCHEMA_MALLOC_FAILED             LDSORABASE + 3 //(8184)
#define ODPP_LDS_ERR_TBLNAME_MALLOC_FAILED            LDSORABASE + 4 //(8185)
#define ODPP_LDS_ERR_TBLQUAL_MALLOC_FAILED            LDSORABASE + 5 //(8186)
#define ODPP_LDS_ERR_COLINFO_MALLOC_FAILED            LDSORABASE + 6 //(8187)
#define ODPP_LDS_ERR_COLNAME_MALLOC_FAILED            LDSORABASE + 7 //(8188)
#define ODPP_LDS_ERR_TMP_COLNAME_MALLOC_FAILED        LDSORABASE + 8 //(8189)
#define ODPP_LDS_ERR_COLNAME_NOT_FOUND                LDSORABASE + 9 //(8190)
#define ODPP_LDS_ERR_STMT_MALLOC_FAILED               LDSORABASE + 10 //(8191)
#define ODPP_LDS_ERR_BIND_HND_MALLOC_FAILED           LDSORABASE + 11 //(8192)
#define ODPP_LDS_ERR_DEFINE_HND_MALLOC_FAILED         LDSORABASE + 12 //(8193)
//#define ODPP_LDS_ERR_UNSUPPORTED_DATATYPE             LDSORABASE + 13 //(8194)
#define ODPP_LDS_ERR_NO_DATA                          LDSORABASE + 14 //(8195)
//Error codes used in Oracle LDS library
#define ODPP_LDS_ERR_CONNNODE_MALLOC_FAILED           LDSORABASE + 15 //(8196)
#define ODPP_LDS_ERR_ORACONN_CLS_ALLOC_FAILED         LDSORABASE + 16 //(8197)
#define ODPP_LDS_ERR_NULL_BASENODE                    LDSORABASE + 17 //(8198)
#define ODPP_LDS_ERR_LDSTOKEN_NOTFOUND                LDSORABASE + 18 //(8199)
#define ODPP_LDS_ERR_STMT_STR_MALLOC_FAILED           LDSORABASE + 19 //(8200)
#define ODPP_LDS_ERR_COLNAME_TO_WCHAR_CNVRT_FAILED    LDSORABASE + 20 //(8201)
#define ODPP_LDS_ERR_UTF16_DATA_BUFFER_MALLOC_FAILED  LDSORABASE + 21 //(8202)
#define ODPP_LDS_ERR_NULL_LDSFLDDEF                   LDSORABASE + 22 //(8203)
#define ODPP_LDS_ERR_COLNAME_UTF16_TO_UTF32_FAILED    LDSORABASE + 23 //(8204)
#define ODPP_LDS_ERR_ENV_CREATE_FAILED                LDSORABASE + 24 //(8205)
#define ODPP_LDS_ERR_ERR_HND_ALLOC_FAILED             LDSORABASE + 25 //(8206)
#define ODPP_LDS_ERR_SVR_HND_ALLOC_FAILED             LDSORABASE + 26 //(8207)
#define ODPP_LDS_ERR_SVCCTX_HND_ALLOC_FAILED          LDSORABASE + 27 //(8208)
#define ODPP_LDS_ERR_SESION_HND_ALLOC_FAILED          LDSORABASE + 28 //(8209)
#define ODPP_LDS_ERR_STMT_HND_ALLOC_FAILED            LDSORABASE + 29 //(8210)
#define ODPP_LDS_ERR_SVR_ATTACH_FAILED                LDSORABASE + 30 //(8211)
#define ODPP_LDS_ERR_SVR_CTX_ATTR_SET_FAILED          LDSORABASE + 31 //(8212)
#define ODPP_LDS_ERR_UNAME_SET_FAILED                 LDSORABASE + 32 //(8213)
#define ODPP_LDS_ERR_PASS_SET_FAILED                  LDSORABASE + 33 //(8214)
#define ODPP_LDS_ERR_LOGIN_FAILED                     LDSORABASE + 34 //(8215)
#define ODPP_LDS_ERR_GET_CHARSET_ID_FAILED            LDSORABASE + 35 //(8216)
#define ODPP_LDS_ERR_SVR_CTX_ATTR_SESION_FAILED       LDSORABASE + 36 //(8217)
#define ODPP_LDS_ERR_SESION_END_FAILED                LDSORABASE + 37 //(8218)
#define ODPP_LDS_ERR_PREPARE_STMT_FAILED              LDSORABASE + 38 //(8219)
#define ODPP_LDS_ERR_BIND_INBUF_FAILED                LDSORABASE + 39 //(8220)
#define ODPP_LDS_ERR_BIND_OUTBUF_FAILED               LDSORABASE + 40 //(8221)
#define ODPP_LDS_ERR_IN_DATETIME_CNVRT_FAILED         LDSORABASE + 41 //(8222)
#define ODPP_LDS_ERR_IN_DATE_CNVRT_FAILED             LDSORABASE + 42 //(8223)
#define ODPP_LDS_ERR_BIND_INBUF_NCHAR_ATTRSET_FAILED  LDSORABASE + 43 //(8224)
#define ODPP_LDS_ERR_BIND_INBUF_SETID_UTF16_FAILED    LDSORABASE + 44 //(8225)
#define ODPP_LDS_ERR_BIND_OUTBUF_NCHAR_ATTRSET_FAILED LDSORABASE + 45 //(8226)
#define ODPP_LDS_ERR_BIND_OUTBUF_SETID_UTF16_FAILED   LDSORABASE + 46 //(8227)
#define ODPP_LDS_ERR_STMT_EXE_FAILED                  LDSORABASE + 47 //(8228)
#define ODPP_LDS_ERR_FETCH_FAILED                     LDSORABASE + 48 //(8229)
#define ODPP_LDS_ERR_DESC_ANY_HND_ALLOC_FAILED        LDSORABASE + 49 //(8230)
#define ODPP_LDS_ERR_TBL_DESC_HND_ALLOC_FAILED        LDSORABASE + 50 //(8231)
#define ODPP_LDS_ERR_COL_PARAM_HND_ALLOC_FAILED       LDSORABASE + 51 //(8232)
#define ODPP_LDS_ERR_GET_COL_COUNT_FAILED             LDSORABASE + 52 //(8233)
#define ODPP_LDS_ERR_GET_COL_LIST_HND_FAILED          LDSORABASE + 53 //(8234)
#define ODPP_LDS_ERR_GET_COL_HND_FAILED               LDSORABASE + 54 //(8235)
#define ODPP_LDS_ERR_GET_COL_NAME_FAILED              LDSORABASE + 55 //(8236)
#define ODPP_LDS_ERR_GET_COL_CHARSETID_FAILED         LDSORABASE + 56 //(8237)
#define ODPP_LDS_ERR_GET_COL_DATATYPE_FAILED          LDSORABASE + 57 //(8238)
#define ODPP_LDS_ERR_GET_COL_LEN_FAILED               LDSORABASE + 58 //(8239)
#define ODPP_LDS_ERR_GET_BIND_DATETIME_DESCRIPTOR_FAILED       LDSORABASE + 59 //(8240)
#define ODPP_LDS_ERR_GET_DEFINE_DATETIME_DESCRIPTOR_FAILED     LDSORABASE + 60 //(8241)
#define ODPP_LDS_ERR_GET_COL_NULLAIBLITY_FAILED       LDSORABASE + 61 //(8242)
#define ODPP_LDS_ERR_GET_COL_BYTES_LEN_FAILED         LDSORABASE + 62 //(8243)
#define ODPP_LDS_ERR_GET_COL_PRECISION_FAILED         LDSORABASE + 63 //(8244)
#define ODPP_LDS_ERR_GET_COL_SCALE_FAILED             LDSORABASE + 64 //(8245)
#define ODPP_LDS_ERR_FREE_STMT_HND_FAILED             LDSORABASE + 65 //(8246)
#define ODPP_LDS_ERR_GET_DATE_FAILED                  LDSORABASE + 66 //(8247)
#define ODPP_LDS_ERR_GET_TIME_FAILED                  LDSORABASE + 67 //(8248)
#define ODPP_LDS_ERR_GET_TIMESTAMP_FAILED             LDSORABASE + 68 //(8249)

// Range 0x00002059(8281) to 0x0000208A(8330)i.e. 50 error codes for
// ODPP Hash library extended errors
#define HASHLIBBASE                                      0x00002059 //(8281)
#define ODPP_HASHLIB_ERR_INIT_FAILED                     HASHLIBBASE + 0 //8281
#define ODPP_HASHLIB_ERR_PARAMVAL_MALLOC_FAILED          HASHLIBBASE + 1 //8282
//#define ODPP_HASHLIB_ERR_ALGO_FAILED                     HASHLIBBASE + 2 //8283
//#define ODPP_HASHLIB_ERR_TERM_FAILED                     HASHLIBBASE + 3 //8284

// Noise Addition:Range 0x0000208B(8331) to 0x0000209A(8346) (16 error codes)
#define ODPPNOISEBASE                                    0x208B             //(8331)
#define ODPP_NOISE_ERR_NO_NOISE_FIELD_PARAM              ODPPNOISEBASE + 0  //(8331)
#define ODPP_NOISE_ERR_UNKNOWN_NOISE_FIELD_PARAM         ODPPNOISEBASE + 1  //(8332)
#define ODPP_NOISE_ERR_INVALID_NOISE_LEVEL_PARAM         ODPPNOISEBASE + 2  //(8333)
#define ODPP_NOISE_ERR_INVALID_STD_DEV_PARAM             ODPPNOISEBASE + 3  //(8334)
#define ODPP_NOISE_ERR_INVALID_MEAN_PARAM                ODPPNOISEBASE + 4  //(8335)
#define ODPP_NOISE_ERR_INVALID_SEED                      ODPPNOISEBASE + 5  //(8336)
#define ODPP_NOISE_ERR_INVALID_RANGE                     ODPPNOISEBASE + 6  //(8337)
#define ODPP_NOISE_ERR_NULL_CTRLBLK                      ODPPNOISEBASE + 7  //(8338)
#define ODPP_NOISE_ERR_MALLOC                            ODPPNOISEBASE + 8  //(8339)
#define ODPP_NOISE_ERR_NON_NUMERIC_TARGET_FIELD          ODPPNOISEBASE + 9  //(8340)

// PRAM: Range  0x0000209B(8347) to 0x000020AA(8362) (16 error codes)
#define ODPPPRAMBASE                                     0x0000209B         // 8347
#define ODPP_PRAM_ERR_INVALID_TRANS_MATRIX               ODPPPRAMBASE + 0   // 8347
#define ODPP_PRAM_ERR_UNKNOWN_CATEGORY                   ODPPPRAMBASE + 1   // 8348
#define ODPP_PRAM_ERR_NULL_PRAM_CTRLBLK                  ODPPPRAMBASE + 2   // 8349
#define ODPP_PRAM_ERR_READING_MATRIX_FILE                ODPPPRAMBASE + 3   // 8350
#define ODPP_PRAM_ERR_NO_PRAM_FIELD                      ODPPPRAMBASE + 4   // 8351
#define ODPP_PRAM_ERR_NO_CATEGORIES                      ODPPPRAMBASE + 5   // 8352

// Range 0x000020AB(8363) to 0x000020DC(8412)i.e. 50 error codes
//UDF DB2 LUW
#define UDFDB2BASE                                                      0x000020AB //8363
#define ODPP_UDF_DB2_TERMINATE                                          UDFDB2BASE + 0//8363
#define ODPP_UDF_ERR_DB2_FUNC_NOT_MATCH_DATATYPE                        UDFDB2BASE + 1//8364
#define ODPP_UDF_ERR_DB2_RET_TYPE_NOT_MATCH_DST_DATATYPE                UDFDB2BASE + 2//8365
#define ODPP_UDF_ERR_DB2_NULL_VALUE                                     UDFDB2BASE + 3//8366
#define ODPP_UDF_ERR_DB2_DST_DATATYPE_NOT_SUPPORTED                     UDFDB2BASE + 4//8367
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_YEAR                            UDFDB2BASE + 5//8368
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_MONTH                           UDFDB2BASE + 6//8369
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_DAY                             UDFDB2BASE + 7//8370
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_HOUR                            UDFDB2BASE + 8//8371
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_MINUTE                          UDFDB2BASE + 9//8372
#define ODPP_UDF_ERR_DB2_FAILED_TO_READ_SECOND                          UDFDB2BASE + 10//8373


// KAnon: Range  0x000020DD(8413) to 0x0000210C(8460) (48 error codes)
#define ODPPKANONBASE                                                   0x000020DD         // 8413
#define ODPP_KANON_ERR_NULL_CTRLBLK                                     ODPPKANONBASE + 0  // 8413
#define ODPP_KANON_ERR_INVALID_SEED                                     ODPPKANONBASE + 1  // 8414
#define ODPP_KANON_ERR_INVALID_K                                        ODPPKANONBASE + 2  // 8415
#define ODPP_KANON_ERR_NO_QID                                           ODPPKANONBASE + 3  // 8416
#define ODPP_KANON_ERR_INVALID_QID_PARAM                                ODPPKANONBASE + 4  // 8417
#define ODPP_KANON_ERR_UNKNOWN_FIELD_PARAM                              ODPPKANONBASE + 5  // 8418
#define ODPP_KANON_ERR_MALLOC                                           ODPPKANONBASE + 6  // 8419

/*=======================================================
   LDS MSS error codes
  ======================================================*/
/* Range 0x0000210D (8461) to 0x0000213E (8510)   -> i.e. 50 error codes */
#define LDSMSSBASE                                       0x0000210D
#define ODPP_LDS_MSS_ERR_NULL_LDSTOKEN                   LDSMSSBASE + 0  //8461 (0x0000210D)
#define ODPP_LDS_MSS_ERR_MALLOCFAILED_CONNNODE           LDSMSSBASE + 1  //8462
#define ODPP_LDS_MSS_ERR_CONNECT_FAILED                  LDSMSSBASE + 2  //8463
#define ODPP_LDS_MSS_ERR_ALLOC_HANDLE_ENV_FAILED         LDSMSSBASE + 3  //8464
#define ODPP_LDS_MSS_ERR_ALLOC_HANDLE_DBC_FAILED         LDSMSSBASE + 4  //8465
#define ODPP_LDS_MSS_ERR_ALLOC_HANDLE_STMT_FAILED        LDSMSSBASE + 5  //8466
#define ODPP_LDS_MSS_ERR_SET_ATTR_ENV_FAILED             LDSMSSBASE + 6  //8467
#define ODPP_LDS_MSS_WARN_NODE_LIST_NOT_EMPTY            LDSMSSBASE + 7  //8468
#define ODPP_LDS_MSS_ERR_NULL_BASENODE                   LDSMSSBASE + 8  //8469
#define ODPP_LDS_MSS_ERR_LDSTOKEN_NOTFOUND               LDSMSSBASE + 9  //8470
#define ODPP_LDS_MSS_ERR_NULL_LDSFLDDEF                  LDSMSSBASE + 10 //8471
#define ODPP_LDS_MSS_ERR_FETCH_COLUMN_FAILED             LDSMSSBASE + 11 //8472
#define ODPP_LDS_MSS_ERR_NO_LDS_COLUMNS                  LDSMSSBASE + 12 //8473
#define ODPP_LDS_MSS_INFO_NO_LOOKUP_DATA                 LDSMSSBASE + 13 //8474
#define ODPP_LDS_MSS_ERR_MALLOCFAILED_STMT_STRING        LDSMSSBASE + 14 //8475
#define ODPP_LDS_MSS_ERR_PREPARE_FAILED                  LDSMSSBASE + 15 //8476
#define ODPP_LDS_MSS_ERR_BINDPARAM_FAILED                LDSMSSBASE + 16 //8477
#define ODPP_LDS_MSS_ERR_UNSUPPORTED_DATATYPE            LDSMSSBASE + 17 //8478
#define ODPP_LDS_MSS_ERR_EXEC_STMT_FAILED                LDSMSSBASE + 18 //8479
#define ODPP_LDS_MSS_ERR_NULL_LOOKUP_BUF                 LDSMSSBASE + 19 //8480
#define ODPP_LDS_MSS_ERR_FREE_STMT_FAILED                LDSMSSBASE + 20 //8481
#define ODPP_LDS_MSS_ERR_READING_COL_DATA                LDSMSSBASE + 21 //8482
#define ODPP_LDS_MSS_ERR_SQLTYPES_ALLOC_FAILED           LDSMSSBASE + 22 //8483
#define ODPP_LDS_MSS_ERR_GET_SQLTYPE_FAILED              LDSMSSBASE + 23 //8484
#define ODPP_LDS_MSS_ERR_MALLOCFAILED_DBCSSTMT_STRING    LDSMSSBASE + 24 //8485
#define ODPP_LDS_MSS_ERR_MALLOCFAILED_DBCS_DATA_BUFFER   LDSMSSBASE + 25 //8486 (0x00002126)
#define ODPP_LDS_MSS_ERR_FETCH_TBL_FAILED                LDSMSSBASE + 26 //8487


//=============================================================================
// Next range to allocate from 0x0000213F (8511)
//=============================================================================

/*=======================================================
   ZOS specific error codes                                           WI 77660
  ======================================================*/
/* Range 0x00002328 (9000) to 0x0000238B (9099)   -> i.e. 100 error codes */
#define ZOSBASE                                          0x00002328
#define ODPP_LDS_ZOS_ERR_TABLE_NOT_FOUND                 ZOSBASE + 0  //9000
#define ODPP_LDS_ZOS_ERR_TABLE_EMPTY                     ZOSBASE + 1  //9001
#define ODPP_LDS_ZOS_ERR_BIND                            ZOSBASE + 2  //9002
#define ODPP_LDS_ZOS_ERR_LOOKUP_FIELD_ERROR              ZOSBASE + 3  //9003                      ,

#endif /*__ODPPCMNERRCODES__*/


