       CBL RENT,DLL,PGMN(LM),LIB,LIST,MAP
      *----------------------------------------------------------------
      *  THIS IS A SAMPLE EXIT FOR IBM'S OPTIM
      *  IT SHOWS AN EXAMPLE OF COBOL CALLING THE ODPP FUNCTION SSN
      *  THE EXIT IS STRUCTURED AS FOLLOWS:
      *  - UPON ENTRY, THE EXIT CHECKS TO SEE IF THIS IS A TERMINATION
      *     CALL (WHICH IS INDICATED BY A VALUE OF 0 IN THE DESTINATION
      *     COLUMN SUBSCRIPT).  IF SO, THE EXIT CLEANS UP AND RETURNS.
      *  - THE EXIT THEN CHECKS TO SEE IF THIS IS THE FIRST TIME IT HAS
      *     BEEN CALLED (INDICATED BY A VALUE OF 0 IN THE WORK AREA).
      *     IF SO, IT DETERMINES THE DESTINATION COLUMN, AND CHECKS THAT
      *      THE DATA TYPE IS COMPATIBLE WITH SSN INFORMATION (IT
      *      CONTAINS CHARACTER, VARCHAR, INT, OR DECIMAL(9,0) DATA.
      *  - IF THE EXIT IS CALLED ON THE FIRST OR SUBSEQUENT DATA COLS,
      *     IT CALLS THE ODPP FUNCTION NID.  IT MOVES THE VALUE BACK
      *     TO THE RETURN COLUMN.
      *  FOR INFORMATION ON THE SQLDA AND SQLVAR, CONSULT THE
      *     APPROPRIATE DB2 DOCUMENTATION FROM IBM.
      *  THIS PROGRAM MUST BE COMPILED WITH THE FOLLOWING OPTIONS:
      *     RENT,DLL,PGMN(LM),LIB
      *----------------------------------------------------------------
       ID DIVISION.
       PROGRAM-ID. "ODPPSSN".
       DATA DIVISION.
      *----------------------------------------------------------------
       WORKING-STORAGE SECTION.
      *----------------------------------------------------------------

      *
      * The following copybook contains ODPP structure definitions
      * and constants
      *
       COPY ODPPWAPI.

       01  EXIT-WORK.
          05  EW-SRC-SQLDA-PTR   POINTER.
          05  EW-DST-SQLDA-PTR   POINTER.
          05  EW-SVC-TOKEN       PIC S9(9) COMP-5.
          05  EW-DST-VAR-SUB     PIC S9(4) COMP-5 SYNC.
          05  EW-SRC-VAR-SUB     PIC S9(4) COMP-5 SYNC.

       01 COLUMN-NAME-INFO.
          05 COL-NAME-DBMS-TYPE PIC X.
          05 FILLER PIC X(3).
          05 COL-NAME-CODE-PAGE PIC S9(9) COMP-5.
          05 COL-NAME-PTR POINTER.

       01 COLUMN-NAME PIC X(30).
       77 NULL-PTR POINTER VALUE NULL.

      *
      * Provider name and country definition (which determines
      * rules for national id format)
      *
       77 PRV-NAME PIC X(4) VALUE Z"NID".
       01 COUNTRY-VAL PIC X(3) VALUE Z"US".
       01 COUNTRY.
          05 COUNTRY-DBMS-TYPE PIC X VALUE 'N'.
          05 FILLER PIC X(3).
          05 COUNTRY-CODE-PAGE PIC S9(9) COMP-5 VALUE -1.
          05 COUNTRY-VAL-PTR POINTER.

       77 CM-ARG-PTR POINTER.
       77 ALLOC-INIT-BLOCK PIC 9 BINARY VALUE 1.
       77 SRC-IS-CHAR          PIC X.
       88 SRC-IS-CHAR-FALSE    VALUE LOW-VALUE.
       88 SRC-IS-CHAR-TRUE     VALUE X'01' THROUGH X'FF'.
       77 SRC-IS-VARCHAR       PIC X.
       88 SRC-IS-VARCHAR-FALSE VALUE LOW-VALUE.
       88 SRC-IS-VARCHAR-TRUE  VALUE X'01' THROUGH X'FF'.
       77 DST-IS-CHAR          PIC X.
       88 DST-IS-CHAR-FALSE    VALUE LOW-VALUE.
       88 DST-IS-CHAR-TRUE     VALUE X'01' THROUGH X'FF'.
       77 DST-IS-VARCHAR       PIC X.
       88 DST-IS-VARCHAR-FALSE VALUE LOW-VALUE.
       88 DST-IS-VARCHAR-TRUE  VALUE X'01' THROUGH X'FF'.
       01 WORK-BYTES       PIC S9(4) COMP-5.
       01 WORK-AREA-OUT-CHAR      PIC X(200).
       01 WORK-AREA-OUT-VARCHAR.
               05 WA-VCR-LEN      PIC S9(4) COMP-5.
               05 WA-VCR-DATA     PIC X(200).
               05 WA-VCR-TERMB    PIC X VALUE SPACE.
               05 WA-VCR-TERMN    PIC 9 VALUE ZERO.
       01 WRK-TALLY1       PIC S9(4) COMP-5.
      *
       LINKAGE SECTION.

       01 INIT-DEST PIC X(200).

      *----------------------------------------------------------------
      *  THIS IS THE LIST OF PARAMETERS THAT ARE PASSED TO THE EXIT
      *  FOR IDENTIFICATION PURPOSES.  IT ALSO INCLUDES THE SUBSCRIPT
      *  OF THE DESTINATION COLUMN THAT WE ARE TO SUPPLY A VALUE TO
      *----------------------------------------------------------------
       01  PARMAREA.
           05  PARMSSN                 PIC X(4).
           05  PARMOPTID               PIC X(4).
           05  PARMUSERID              PIC X(8).
           05  PARMSQLID               PIC X(128).
           05  PARMSCRIDV              PIC X(128).
           05  PARMSTBNML              PIC S9(4) COMP-5.
           05  PARMSTBNMV              PIC X(128).
           05  PARMDCRIDV              PIC X(128).
           05  PARMDTBNML              PIC S9(4) COMP-5.
           05  PARMDTBNMV              PIC X(128).
           05  PARMDESTSUB             PIC S9(4) COMP-5.
           05  PARMFLAG                PIC 9.
           05  FILLER                  PIC X.
           05  PARM-GLOBAL-WORK        POINTER.
           05  PARM-TABLE-WORK         POINTER.
           05  PARM-USER-PARMS         POINTER.
           05  PARM-CURRENT-ROWNUM     PIC S9(9) COMP-5.
           05  PARM-TOTAL-TABLEROWS    PIC S9(9) COMP-5.
      *----------------------------------------------------------------
      *  THIS IS THE SQLDA FOR THE SOURCE ROW.  IT DESCRIBES THE TYPE,
      *  LENGTH AND ADDRESS OF EACH COLUMN IN THE SOURCE ROW.
      *----------------------------------------------------------------
       01  SSQLDA.
           05  SSQLDAID                PIC X(8).
           05  SSQLDABC                PIC S9(9) COMP-5 SYNC.
           05  SSQLN                   PIC S9(4) COMP-5 SYNC.
           05  SSQLD                   PIC S9(4) COMP-5 SYNC.
           05  SSQLVAR                 OCCURS 1 TO 300 TIMES
                                       DEPENDING ON SSQLN
                                       INDEXED BY SSQLVAR-IX.
               10  SSQLTYPE            PIC S9(4) COMP-5 SYNC.
               10  SSQLLEN             PIC S9(4) COMP-5 SYNC.
               10  SSQLDECINFO         REDEFINES SSQLLEN.
                   15 SSQLPRECISION    PIC X.
                   15 SSQLSCALE        PIC X.
               10  SSQLDATA            POINTER.
               10  SSQLIND             POINTER.
               10  SSQLNAME.
                   15  SSQLNAMEL       PIC S9(4) COMP-5 SYNC.
                   15  SSQLNAMEC       PIC X(30).
      *----------------------------------------------------------------
      *  THIS IS THE SQLDA FOR THE DESTINATION ROW.  IT IS IDENTICAL TO
      *  THE SOURCE SQLDA BUT SHOWS THE DATA FOR THE DESTINATION TABLE.
      *----------------------------------------------------------------
       01  DSQLDA.
           05  DSQLDAID                PIC X(8).
           05  DSQLDABC                PIC S9(9) COMP-5 SYNC.
           05  DSQLN                   PIC S9(4) COMP-5 SYNC.
           05  DSQLD                   PIC S9(4) COMP-5 SYNC.
           05  DSQLVAR                 OCCURS 1 TO 300 TIMES
                                       DEPENDING ON DSQLN
                                       INDEXED BY DSQLVAR-IX.
               10  DSQLTYPE            PIC S9(4) COMP-5 SYNC.
               10  DSQLLEN             PIC S9(4) COMP-5 SYNC.
               10  DSQLDECINFO         REDEFINES DSQLLEN.
                   15 DSQLPRECISION    PIC X.
                   15 DSQLSCALE        PIC X.
               10  DSQLDATA            POINTER.
               10  DSQLIND             POINTER.
               10  DSQLNAME.
                   15  DSQLNAMEL       PIC S9(4) COMP-5 SYNC.
                   15  DSQLNAMEC       PIC X(30).

       01 COLEXIT-AREA.
          05 WA-RETURN-MSG PIC X(252).
          05 WA-EXIT-WORK-PTR POINTER.
          05 WA-LOGGING       PIC X.
             88 LOGGING        VALUE 'Y'.
             88 NOT-LOGGING    VALUE 'N'.
          05 WA-DEST-COL-TYPE PIC X.
             88 WA-TYPE-INTEGER VALUE 'I'.
             88 WA-TYPE-DECIMAL VALUE 'D'.
             88 WA-TYPE-CHAR    VALUE 'C'.
             88 WA-TYPE-VARCHAR VALUE 'V'.
          05 WA-NULLABLE      PIC X.
             88 IS-NULLABLE    VALUE 'Y'.
             88 NOT-NULLABLE   VALUE 'N'.
          05 FILLER           PIC X.
          05 WA-PRECISION     PIC 99 USAGE COMP.
          05 WA-BYTES-TO-MOVE PIC 99 USAGE COMP.
          05 WA-PROV-TOKEN-SSN COMP-2.
          05 WA-IX-SAVE             PIC S9(9) COMP-5 SYNC.
          05 WA-DESTSUB             PIC S9(4) COMP-5.
          05 WA-FP-PROV-INIT USAGE FUNCTION-POINTER.
          05 WA-FP-PROV-SRVC USAGE FUNCTION-POINTER.
          05 WA-FP-PROV-TERM USAGE FUNCTION-POINTER.

       PROCEDURE DIVISION USING PARMAREA SSQLDA DSQLDA COLEXIT-AREA.
           MOVE 0 TO RETURN-CODE

      *
      * Rows are available for processing when the destination
      * subscript is greater than zero.  Otherwise this is a
      * termination call and clean up is done.
      *
           IF PARMDESTSUB > 0 THEN

      *
      * If this is the first row then initialize ODPP services
      *
             IF PARM-CURRENT-ROWNUM = 1 THEN
               MOVE LOW-VALUES TO EXIT-WORK

      *
      * Match the destination column to the source column
      *
               MOVE PARMDESTSUB TO EW-DST-VAR-SUB
               SET DSQLVAR-IX TO PARMDESTSUB
               SET SSQLVAR-IX TO 1
               SEARCH SSQLVAR
                 AT END
                   MOVE 8 TO RETURN-CODE
                   DISPLAY "Cannot match destination to source column"
                 WHEN SSQLNAMEC(SSQLVAR-IX) = DSQLNAMEC(DSQLVAR-IX)
                   SET EW-SRC-VAR-SUB TO SSQLVAR-IX
               END-SEARCH
               IF RETURN-CODE NOT = 0 THEN
                 GOBACK
               END-IF

      *
      * Initialize the ODPP framework
      *
               SET CM-ARG-PTR TO NULL
               CALL 'Provider_FrmwInit'
                 USING
                   BY VALUE CM-ARG-PTR
                 RETURNING RETURN-CODE
               IF RETURN-CODE = ODPP-OS-LIB-MUTEX-ALREADY-INIT THEN
                 MOVE 0 TO RETURN-CODE
               ELSE
                 IF RETURN-CODE NOT = 0 THEN
                   DISPLAY
                     "Framework initialization failed rc=" RETURN-CODE
                   GOBACK
                 END-IF
               END-IF

      *
      * Initialize the Service Provider
      *
      *                           Service Definition body
               MOVE LOW-VALUES TO DP-SVC-DEF-BODY
      *                           Field Definition body
               MOVE LOW-VALUES TO DP-FIELD-DEF-BODY(1)
      *                           Initialization parms for
      *                           current service.
               MOVE LOW-VALUES TO DP-INIT-OP-DEF-BODY(1),
                             DP-INIT-OP-DEF-BODY(2),
                             DP-INIT-OP-DEF-BODY(3),
                             DP-INIT-OP-DEF-BODY(4)

               MOVE LENGTH OF DP-SVC-DEF TO STRUCT-LEN OF DP-SVC-DEF
               COMPUTE STRUCT-LEN OF DP-FIELD-DEF-ARRAY(1)
                 = LENGTH OF DP-FIELD-DEF-HEADER
                   + LENGTH OF DP-FIELD-DEF-BODY
               COMPUTE STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(1),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(2),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(3),
                       STRUCT-LEN OF DP-INIT-OP-DEF-ARRAY(4)
                 = LENGTH OF DP-INIT-OP-DEF-HEADER
                   + LENGTH OF DP-INIT-OP-DEF-BODY

      *       * Show where the first Initialization parameter
      *       *  block is located.
               SET PARAMS-PTR TO ADDRESS OF DP-INIT-OP-DEF-ARRAY(1)
      *       * Show where the first field definition block is
      *       * located.
               SET FLD-DEF-PTR TO ADDRESS OF DP-FIELD-DEF-ARRAY(1)
               MOVE X"01" TO COPY-TO-DEST

      *        "M" represents specifying column name in
      *        character (SBCS/MBCS) format.
      *        This is normally used for z/OS environment.
               MOVE "M" TO SUB-TYPE(1)

               MOVE LOW-VALUES TO COLUMN-NAME-INFO
               MOVE SPACES TO COLUMN-NAME
               MOVE
                 SSQLNAMEC(EW-SRC-VAR-SUB)(1:SSQLNAMEL(EW-SRC-VAR-SUB))
                 TO COLUMN-NAME
               MOVE 30 TO COL-NAME-BYTES(1)
               SET MC-PTR(1) TO ADDRESS OF COLUMN-NAME-INFO
               SET COL-NAME-PTR TO ADDRESS OF COLUMN-NAME
               MOVE RDB-NONE TO COL-NAME-DBMS-TYPE
               MOVE -1 TO COL-NAME-CODE-PAGE

               MOVE RDB-NONE TO DATA-DBMS-TYPE(1)
      *        Use -1 to default to system environment
      *        defined code page.
               MOVE -1 TO DATA-CODE-PAGE(1)
      *        Determine the datatype of Input
      *        DISPLAY "VAL OF SRC DATATYPE " SSQLTYPE(EW-SRC-VAR-SUB)
               MOVE LOW-VALUE TO SRC-IS-CHAR
               MOVE LOW-VALUE TO SRC-IS-VARCHAR
               MOVE LOW-VALUE TO DST-IS-CHAR
               MOVE LOW-VALUE TO DST-IS-VARCHAR
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-CHAR OR
                   SSQLTYPE(EW-SRC-VAR-SUB)= DB2-CHAR + 1 THEN
                 MOVE ODPPDATATYPE-CHAR TO DATA-TYPE(1)
      *          DISPLAY "PROCESSING SOURCE CHAR FIELD"
                 MOVE X'01' TO SRC-IS-CHAR
                 END-IF
               IF SSQLTYPE(EW-SRC-VAR-SUB) = DB2-VARCHAR OR
                   SSQLTYPE(EW-SRC-VAR-SUB) = DB2-VARCHAR + 1 THEN
                 MOVE ODPPDATATYPE-VARCHAR TO DATA-TYPE(1)
                 MOVE X'01' TO SRC-IS-VARCHAR
      *          DISPLAY "PROCESSING SOURCE VARCHAR FIELD"
                 END-IF
               MOVE SSQLLEN(EW-SRC-VAR-SUB) TO COL-LENGTH(1)
      *        Determine the datatype of Output
      *        DISPLAY "VAL OF DEST DATATYPE " DSQLTYPE(EW-DST-VAR-SUB)
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-CHAR OR
                   DSQLTYPE(EW-DST-VAR-SUB)= DB2-CHAR + 1 THEN
                 MOVE X'01' TO DST-IS-CHAR
      *          DISPLAY "PROCESSING DEST CHAR FIELD"
                 END-IF
               IF DSQLTYPE(EW-DST-VAR-SUB) = DB2-VARCHAR OR
                   DSQLTYPE(EW-DST-VAR-SUB) = DB2-VARCHAR + 1 THEN
                 MOVE X'01' TO DST-IS-VARCHAR
      *          DISPLAY "PROCESSING DEST VARCHAR FIELD"
                 END-IF
      *        Number of DP-FIELD-DATA-DEF blocks
               MOVE 1 TO FLD-COUNT
      *        Set the number of parameters
      *        (DP-INIT-OP-DEF-ARRAY blocks) for this
      *        Provider Service.
               MOVE 4 TO PARAM-COUNT

      *
      * Initialize the ODPP rowset, row and field  structures
      *
               MOVE LOW-VALUES TO DP-ROWSET-DEF-BODY
               SET NEXT-PTR OF DP-ROW-DEF TO NULL
               MOVE LENGTH OF DP-ROWSET-DEF
                 TO STRUCT-LEN OF DP-ROWSET-DEF
      *        Will always be 1 in an Optim/z Column Map Exit.
               MOVE 1 TO ROW-COUNT OF DP-ROWSET-DEF

               MOVE LOW-VALUES TO DP-ROW-DEF
               MOVE LENGTH OF DP-ROW-DEF
                 TO STRUCT-LEN OF DP-ROW-DEF

               MOVE LOW-VALUES TO DP-FIELD-DATA-DEF-BODY(1)
               SET NEXT-PTR OF DP-FIELD-DATA-DEF-ARRAY(1) TO NULL
               MOVE LENGTH OF DP-FIELD-DATA-DEF-ARRAY(1)
                 TO STRUCT-LEN OF DP-FIELD-DATA-DEF-ARRAY(1)

      *       *
      *       * Initialization parameters for NID
      *       *
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(1) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(2)
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(2) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(3)
               SET NEXT-PTR OF DP-INIT-OP-DEF-ARRAY(3) TO
                 ADDRESS OF DP-INIT-OP-DEF-ARRAY(4)
               MOVE ODPP-OPR-SWITCH-LITERAL TO PARAMETER-ID(1)
               MOVE PARAM-VAL-MC TO VALUE-SUB-TYPE(1)
      *       *
      *       * Determination made here that this NID is for SSN
      *       *
               SET COUNTRY-VAL-PTR TO ADDRESS OF COUNTRY-VAL
               SET PARAM-VAL-PTR(1) TO ADDRESS OF COUNTRY
               MOVE LENGTH OF COUNTRY-VAL TO VALUE-BUF-BYTES(1)
               MOVE ODPP-OPR-SOURCE-COLINDEX TO PARAMETER-ID(2)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(2)
               MOVE 0 TO PARAM-VAL-INT(2)
               MOVE ODPP-OPR-METHOD TO PARAMETER-ID(3)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(3)
               MOVE ODPP-METHOD-MASK TO PARAM-VAL-INT(3)

               MOVE ODPP-OPR-NID-US-SEP TO PARAMETER-ID(4)
               MOVE PARAM-VAL-NUM TO VALUE-SUB-TYPE(4)
               MOVE ODPP-SEP-DASH TO PARAM-VAL-INT(4)

               CALL 'Provider_Init'
                 USING
                   BY VALUE ADDRESS OF EW-SVC-TOKEN,
                   BY VALUE ADDRESS OF PRV-NAME,
                   BY VALUE 3,
                   BY VALUE ADDRESS OF DP-SVC-DEF,
                   BY VALUE ALLOC-INIT-BLOCK
                 RETURNING RETURN-CODE
               IF RETURN-CODE NOT = 0 THEN
                 DISPLAY
                   "Provider initialization failed rc=" RETURN-CODE
                 GOBACK
               END-IF
             END-IF

      * Continue processing - for every row ...
      *
      * Populate the rowset structure
      *
             SET ROW-DEFINE-PTR TO ADDRESS OF DP-ROW-DEF
             MOVE 0 TO LAST-PRCS-ROW
             MOVE X"00" TO PROCESSED
             MOVE X"00" TO HAS-ERROR
             MOVE X"00" TO SRC-NULL(1)

      *
      * Set up the data definition structure
      *
             MOVE SSQLLEN(EW-SRC-VAR-SUB) TO SRC-BUF-LEN(1)
             SET SRC-BUF-PTR(1) TO SSQLDATA(EW-SRC-VAR-SUB)
             MOVE DSQLLEN(PARMDESTSUB) TO DST-BUF-LEN(1)
      *      If source is char and dest is varchar - convert
             IF SRC-IS-CHAR-TRUE AND DST-IS-VARCHAR-TRUE
               SET DST-BUF-PTR(1) TO ADDRESS OF WORK-AREA-OUT-CHAR
               MOVE ZERO   TO WA-VCR-LEN
      *      If source is varchar and dest is char - convert
             ELSE
               IF SRC-IS-VARCHAR-TRUE AND DST-IS-CHAR-TRUE
                 SET DST-BUF-PTR(1) TO
                      ADDRESS OF WORK-AREA-OUT-VARCHAR
               ELSE
                 SET DST-BUF-PTR(1) TO DSQLDATA(PARMDESTSUB)
               END-IF
             END-IF

      *
      * Set up the row definition structure
      *
             SET FLD-DATA-DEFINE-PTR TO
                 ADDRESS OF DP-FIELD-DATA-DEF-ARRAY(1)
             MOVE 1 TO S-COUNT OF DP-ROW-DEF

      *
      * Call the provider service
      *
             CALL 'Provider_Service'
               USING
                 BY VALUE EW-SVC-TOKEN,
                 BY VALUE ODPP-METHOD-DEFAULT,
                 BY VALUE NULL-PTR,
                 BY VALUE ADDRESS OF DP-ROWSET-DEF
               RETURNING RETURN-CODE
             IF RETURN-CODE NOT = 0 THEN
               DISPLAY "NID service failed rc=" RETURN-CODE
               GOBACK
             END-IF
      *      Clear remaining bytes of area if CHAR field
             IF SRC-IS-CHAR-TRUE THEN
               IF DSQLLEN(EW-DST-VAR-SUB) > DST-BUF-LEN(1)
                 COMPUTE WORK-BYTES = DSQLLEN(EW-DST-VAR-SUB) -
                         DST-BUF-LEN(1)
                 SET ADDRESS OF INIT-DEST TO DST-BUF-PTR(1)
                 MOVE SPACE TO INIT-DEST(DST-BUF-LEN(1) + 1: WORK-BYTES)
               END-IF
             END-IF
      *      If source is char and dest is varchar - convert
             IF SRC-IS-CHAR-TRUE AND DST-IS-VARCHAR-TRUE
               MOVE ZERO TO WRK-TALLY1
               INSPECT WORK-AREA-OUT-CHAR TALLYING WRK-TALLY1
                  FOR CHARACTERS BEFORE INITIAL X'00'
               MOVE WRK-TALLY1 TO WA-VCR-LEN
               MOVE SPACES TO WA-VCR-DATA
               MOVE WORK-AREA-OUT-CHAR(1:DST-BUF-LEN(1)) TO WA-VCR-DATA
               SET ADDRESS OF INIT-DEST TO DSQLDATA(PARMDESTSUB)
               COMPUTE WORK-BYTES = DSQLLEN(PARMDESTSUB) + 2
               MOVE WORK-AREA-OUT-VARCHAR(1:WORK-BYTES) TO
                    INIT-DEST
             END-IF
      *      If source is varchar and dest is char - convert
             IF SRC-IS-VARCHAR-TRUE AND DST-IS-CHAR-TRUE
               MOVE SPACES TO WORK-AREA-OUT-CHAR
               MOVE WA-VCR-DATA (1 : WA-VCR-LEN) TO WORK-AREA-OUT-CHAR
               SET ADDRESS OF INIT-DEST TO DSQLDATA(PARMDESTSUB)
               MOVE WORK-AREA-OUT-CHAR (1:DSQLLEN(PARMDESTSUB)) TO
                     INIT-DEST
             END-IF

             MOVE 0 TO RETURN-CODE
           ELSE
      *
      *      This is the Termination call from Column Map services.
      *      Clean up the Provider Service environment.
      *
             CALL 'Provider_Term'
               USING
                 BY VALUE EW-SVC-TOKEN
               RETURNING RETURN-CODE

           END-IF.
           GOBACK.
