//<NAME> JOB ,TIME=(,30),MSGCLASS=H,MSGLEVEL=(1,1),
// NOTIFY=&SYSUID,REGION=0M
//*
//* NOTES ABOUT JOB CARD:
//*   - ENSURE THERE IS ENOUGH MEMORY (REGION=).  OPTIM DATA
//*       PRIVACY REQUIRES APPROX 120M BY ITSELF.
//*   - ENSURE THERE IS ENOUGH TIME.  WHEN TIME EXPIRES AND
//*       APF AUTHORIZED CODE IS BEING EXECUTED, THE RESULTING
//*       ABEND MAY NOT LOOK LIKE AN OUT-OF-TIME CONDITION.
//*
//*******************************************************************
//*
//*    LICENSED MATERIALS - PROPERTY OF IBM
//*    5655-O30, 5655-O27, 5655-QCC, 5655-O19, 5655-O24, 5655-QCA,
//*    5655-QCB, 5655-O26
//*    (C) COPYRIGHT 2015 IBM CORP.
//*
//* SAMPLE JCL - INVOKES DB2 HIGH PERFORMANCE UNLOAD FOR Z/OS WITH
//*   AN INFOSPHERE OPTIM DATA PRIVACY HPU USER EXIT.  ALLOWS MASKING
//*   COLUMNS WHILE UNLOADING DATA FROM DB2.
//*
//* CUSTOMIZATION REQUIRED:
//*
//* IOQHLOAD : THE LOAD LIBRARY CONTAINING THE IOQHPUX EXIT.
//*   NOTE: HPU REQUIRES THAT THIS LOAD LIBRARY IS APF AUTHORIZED.
//* IOQHENV : THE ODPP ENVIRONMENT FILE CREATED AT ODPP INSTALL TIME.
//*   IT CONTAINS SETTINGS FOR THE ODPP ENVIRONMENT VARIABLES.
//* IOQCMD1 : THE CMD FILE FOR THE IOQSHPUX USER EXIT.
//*
// SET IOQHLOAD=<HLQ>.IOQSHPUX.LOAD
// SET IOQHENV=<HLQ>.IOQSHPUX.ODPPENV(E1132EA)
// SET IOQCMD1=<HLQ>.IOQSHPUX.JCL(IOQSHCMD)
//*
//* ALSO: SET THE SUBSYSTEM ID FOR THE DB2 FROM WHICH TO UNLOAD.
//*   THAT IS IN THE PARM=SSID,HPU STATEMENT A FEW LINES BELOW.
//*
//* YOU MAY ALSO NEED TO CHANGE THE STEPLIB LIBRARY NAMES.
//*
//*******************************************************************
//*
//HPU       EXEC PGM=INZUTILB,
//             PARM='DDAF,HPU'
//STEPLIB      DD DSN=DSN.HPU410.SINZLINK,DISP=SHR
//             DD DSN=DSN.DB2VA10.SDSNLOAD,DISP=SHR
//             DD DSN=&IOQHLOAD,DISP=SHR
//SYSPRINT DD SYSOUT=*
//SYSREC1  DD SYSOUT=*
//LOADCMD1 DD SYSOUT=*
//*
//*******************************************************************
//* THE FOLLOWING DD DEFS ARE FOR OPTIM MASKING PURPOSES:
//*
//* IOQCMD  : MASKING COMMAND INPUT  (REQUIRED)
//* IOQRPRT : MASKING REPORT OUTPUT  (REQUIRED)
//* IOQENV  : ODPP ENVIRONMENT FILE  (REQUIRED)
//* CEEOPTS : SETS THE IOQSHPUX EXIT LE EXECUTION ENV.  (REQUIRED)
//* CEEDUMP : USEFUL IN CASE OF AN ABEND.  (OPTIONAL)
//*
//IOQCMD   DD DSN=&IOQCMD1,DISP=SHR
//IOQRPRT  DD SYSOUT=*
//IOQENV   DD DSN=&IOQHENV,DISP=SHR
//CEEOPTS  DD *
   ENVAR(_CEE_ENVFILE_S=DD:IOQENV),POSIX(ON)
//CEEDUMP  DD SYSOUT=*
//*
//*******************************************************************
//*
//* EXAMPLE COMMAND FOR HPU: UNLOAD OPTIM SAMPLE TABLE OPTIM_ITEMS.
//*   ASSUMES THE CREATOR NAME OF TABLE OPTIM_ITEMS IS FOPDEMO.
//*   ASSUMES THE TABLE IS IN TABLESPACE DEMODB.DEMOTS.
//*
//SYSIN    DD *
 UNLOAD TABLESPACE DEMODB.DEMOTS
 DB2 NO
 SELECT *
 FROM FOPDEMO.OPTIM_SALES
 OUTDDN SYSREC1
 LOADDDN LOADCMD1
 FORMAT VARIABLE END
 OUTEXIT IOQSHPUX COBOL2
 ASIS
/*
